env.info("CTLD : is loading.")

local my_ctld = CTLD:New(coalition.side.BLUE,{"CH.47", "UH.1H", "Hercules", "Mi.8M", "AH.64"},"Lufttransportbrigade I")
local herccargo = CTLD_HERCULES:New("blue", "Hercules Test", my_ctld)
my_ctld.useprefix = true
my_ctld.dropcratesanywhere = true
my_ctld.forcehoverload = false
my_ctld.enableHercules = true
my_ctld.HercMinAngels = 155 -- for troop/cargo drop via chute in meters, ca 470 ft
my_ctld.HercMaxAngels = 2000 -- for troop/cargo drop via chute in meters, ca 6000 ft
my_ctld.HercMaxSpeed = 77 -- 77mps or 270kph or 150kn
my_ctld.allowcratepickupagain = true
my_ctld.nobuildinloadzones = true
my_ctld.movecratesbeforebuild = true
my_ctld.movetroopstowpzone = true
my_ctld.enableChinhookGCLoading = true
my_ctld.hoverautoloading = false
my_ctld.enableslingload = true
my_ctld.pilotmustopendoors = true
my_ctld:__Start(10)
my_ctld.buildtime = 30
my_ctld.basetype = "ammo_cargo"

-- generate generically loadable stuff
my_ctld:AddTroopsCargo("Squad 8",{"ATS"},CTLD_CARGO.Enum.TROOPS,8,80)
my_ctld:AddTroopsCargo("Platoon 16",{"Platon16"},CTLD_CARGO.Enum.TROOPS,16,80)
my_ctld:AddTroopsCargo("Platoon 32",{"Platon1"},CTLD_CARGO.Enum.TROOPS,32,80)
my_ctld:AddTroopsCargo("Anti-Air Soldiers",{"AA"},CTLD_CARGO.Enum.TROOPS,4,80)
my_ctld:AddTroopsCargo("Mortar Squad",{"MRS"},CTLD_CARGO.Enum.TROOPS,6,80)
my_ctld:AddCratesCargo("ATGM Humvee",{"ATGM HMMWV"},CTLD_CARGO.Enum.VEHICLE,2,200)
my_ctld:AddCratesCargo("HAWK Site",{"HAWKSite"},CTLD_CARGO.Enum.VEHICLE,5,200)
my_ctld:AddCratesCargo("Ammo Truck",{"AmmoTruck"},CTLD_CARGO.Enum.VEHICLE,2,200)
--my_ctld:AddCratesCargo("Forward Ops Base",{"FOB"},CTLD_CARGO.Enum.FOB,4,100)
my_ctld:AddCratesCargo("Linebacker",{"Linebacker"},CTLD_CARGO.Enum.VEHICLE,3,100)
my_ctld:AddCratesCargo("Vulcan",{"Vulcan"}, CTLD_CARGO.Enum.VEHICLE, 5, 2000, nil, "SAM/AAA")

my_ctld:AddCratesCargo("FARP with ammo and fuel",{"FOB"},CTLD_CARGO.Enum.FOB,2,3000)


my_ctld:AddTroopsCargo("technician Solider ",{"Engineers"},CTLD_CARGO.Enum.ENGINEERS,1,80)
my_ctld:AddTroopsCargo("technician Humvee ",{"EngineersHMM"},CTLD_CARGO.Enum.ENGINEERS,1,500)

-- generate zone types

my_ctld:AddCTLDZone("Sde Dov",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Ben-Gurion",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Palmahim",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Tel Nof",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Hatzor",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Kedem-Hatzerim",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Nevatim",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Ramon Airbase",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("El Gora",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("El Arish",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Ovda",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("St Catherine",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Abu Rudeis",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Bir Hasanah",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Melez",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Baluza",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Al Mansurah",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("As Salihiyah",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Al Ismailiyah",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Abu Suwayr",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("AzZaqaziq",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Difarsuwar Airfield",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Fayed",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Kibrit Air Base",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Bilbeis Air Base",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Inshas Airbase",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Cairo International Airport",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Wadi al Jandali",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Cairo West",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Sharm El Sheikh International Airport",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Hurghada International Airport",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Beni Suef",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Kom Awshim",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Quwaysina",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("Birma Air Base",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)


my_ctld:AddCTLDZone("FARP-Alpha",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("FARP-Bravo",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("FARP-Charlie",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("FARP-Delta",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("FARP-Echo",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("FARP-Foxtrot",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("FARP-Golf",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("FARP-Hotel",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("FARP-India",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("FARP-Juliett",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("FARP-Kilo",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("FARP-Lima",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)
my_ctld:AddCTLDZone("FARP-Mike",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,false)


my_ctld:AddCTLDZone("DropZone",CTLD.CargoZoneType.DROP,SMOKECOLOR.Orange,true,false)

my_ctld:AddCTLDZone("Sde Dov",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Ben-Gurion",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Palmahim",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Tel Nof",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Hatzor",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Kedem-Hatzerim",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Nevatim",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Ramon Airbase",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("El Gora",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("El Arish",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Ovda",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("St Catherine",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Abu Rudeis",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Bir Hasanah",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Melez",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Baluza",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Al Mansurah",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("As Salihiyah",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Al Ismailiyah",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Abu Suwayr",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("AzZaqaziq",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Difarsuwar Airfield",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Fayed",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Kibrit Air Base",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Bilbeis Air Base",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Inshas Airbase",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Cairo International Airport",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Wadi al Jandali",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Cairo West",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Sharm El Sheikh International Airport",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Hurghada International Airport",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Beni Suef",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Kom Awshim",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Quwaysina",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("Birma Air Base",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)

my_ctld:AddCTLDZone("FARP-Alpha",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("FARP-Bravo",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("FARP-Charlie",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("FARP-Delta",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("FARP-Echo",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("FARP-Foxtrot",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("FARP-Golf",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("FARP-Hotel",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("FARP-India",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("FARP-Juliett",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("FARP-Kilo",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("FARP-Lima",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("FARP-Mike",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)


my_ctld:AddCTLDZone("SAM-Alpha",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("SAM-Bravo",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("SAM-Charlie",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("SAM-Delta",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("SAM-Echo",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("SAM-Foxtrot",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("SAM-Golf",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("SAM-Hotel",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("SAM-India",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("SAM-Juliett",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("SAM-Kilo",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("SAM-Lima",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)
my_ctld:AddCTLDZone("SAM-Mike",CTLD.CargoZoneType.MOVE,SMOKECOLOR.Green,true,false)

my_ctld:SetUnitCapabilities("SA342Mistral", false, true, 0, 2, 10, 400)
my_ctld:SetUnitCapabilities("SA342L", false, true, 0, 2, 10, 400)
my_ctld:SetUnitCapabilities("SA342M", false, true, 0, 2, 10, 400)
my_ctld:SetUnitCapabilities("SA342Minigun", false, true, 0, 2, 10, 400)
my_ctld:SetUnitCapabilities("UH-1H", true, true, 1, 8, 15, 800)
my_ctld:SetUnitCapabilities("Mi-8MT", true, true, 2, 16, 15, 2000)
my_ctld:SetUnitCapabilities("Mi-8MTV2", true, true, 2, 18, 15, 6000)
my_ctld:SetUnitCapabilities("Ka-50", false, false, 0, 0, 15, 400)
my_ctld:SetUnitCapabilities("Mi-24P", true, true, 2, 8, 15, 1000)
my_ctld:SetUnitCapabilities("Mi-24V", true, true, 2, 8, 15, 1000)
my_ctld:SetUnitCapabilities("Hercules", true, true, 8, 20, 15, 20000)
my_ctld:SetUnitCapabilities("UH-60L", true, true, 2, 16, 15, 2000)
my_ctld:SetUnitCapabilities("AH-64D_BLK_II", true, true, 4, 2, 15, 400)
my_ctld:SetUnitCapabilities("CH-47Fbl1", true, true, 5, 32, 20, 8000)
--BASE:TraceOn()
--BASE:TraceClass("CTLD")

   --[[ Default unit type capabilities are: 
   ["SA342Mistral"] = {type="SA342Mistral", crates=false, troops=true, cratelimit = 0, trooplimit = 4, length = 12, cargoweightlimit = 400},
   ["SA342L"] = {type="SA342L", crates=false, troops=true, cratelimit = 0, trooplimit = 2, length = 12, cargoweightlimit = 400},
   ["SA342M"] = {type="SA342M", crates=false, troops=true, cratelimit = 0, trooplimit = 4, length = 12, cargoweightlimit = 400},
   ["SA342Minigun"] = {type="SA342Minigun", crates=false, troops=true, cratelimit = 0, trooplimit = 2, length = 12, cargoweightlimit = 400},
   ["UH-1H"] = {type="UH-1H", crates=true, troops=true, cratelimit = 1, trooplimit = 8, length = 15, cargoweightlimit = 700},
   ["Mi-8MT"] = {type="Mi-8MT", crates=true, troops=true, cratelimit = 2, trooplimit = 12, length = 15, cargoweightlimit = 3000},
   ["Mi-8MTV2"] = {type="Mi-8MTV2", crates=true, troops=true, cratelimit = 2, trooplimit = 12, length = 15, cargoweightlimit = 3000},
   ["Ka-50"] = {type="Ka-50", crates=false, troops=false, cratelimit = 0, trooplimit = 0, length = 15, cargoweightlimit = 0},
   ["Mi-24P"] = {type="Mi-24P", crates=true, troops=true, cratelimit = 2, trooplimit = 8, length = 18, cargoweightlimit = 700},
   ["Mi-24V"] = {type="Mi-24V", crates=true, troops=true, cratelimit = 2, trooplimit = 8, length = 18, cargoweightlimit = 700},
   ["Hercules"] = {type="Hercules", crates=true, troops=true, cratelimit = 7, trooplimit = 64, length = 25, cargoweightlimit = 19000},
   ["UH-60L"] = {type="UH-60L", crates=true, troops=true, cratelimit = 2, trooplimit = 20, length = 16, cargoweightlimit = 3500},
   ["AH-64D_BLK_II"] = {type="AH-64D_BLK_II", crates=false, troops=true, cratelimit = 0, trooplimit = 2, length = 17, cargoweightlimit = 200}, 
   ["CH-47Fbl1"] = {type="CH-47Fbl1", crates=true, troops=true, cratelimit = 4, trooplimit = 31, length = 20, cargoweightlimit = 8000},
   --]] 
--FARP Radio. First one has 130AM, next 131 and for forth
   -- FARP Radio. First one has 130AM name London, next 131 name Dallas, and so forth. 
     local FARPFreq = 129
     local FARPName = 1  --numbers 1..10

     local FARPClearnames = {
       [1]="London",
       [2]="Dallas",
       [3]="Paris",
       [4]="Moscow",
       [5]="Berlin",
       [6]="Rome",
       [7]="Madrid",
       [8]="Warsaw",
       [9]="Dublin",
       [10]="Perth",
       }
		local BuiltFARPCoordinates = {}
     function BuildAFARP(Coordinate)
       local coord = Coordinate  --Core.Point#COORDINATE

       local FarpNameNumber = ((FARPName-1)%10)+1 -- make sure 11 becomes 1 etc
       local FName = FARPClearnames[FarpNameNumber] -- get clear namee

       FARPFreq = FARPFreq + 1
       FARPName = FARPName + 1

		
		
       FName = FName .. " FAT COW "..tostring(FARPFreq).."AM" -- make name unique
		
		table.insert(BuiltFARPCoordinates, {name = FName, coord = coord})
		
       -- Get a Zone for loading 
       local ZoneSpawn = ZONE_RADIUS:New("FARP "..FName,Coordinate:GetVec2(),150,false)

       -- Spawn a FARP with our little helper and fill it up with resources (10t fuel each type, 10 pieces of each known equipment)
       UTILS.SpawnFARPAndFunctionalStatics(FName,Coordinate,ENUMS.FARPType.INVISIBLE,my_ctld.coalition,country.id.USA,FarpNameNumber,FARPFreq,radio.modulation.AM,nil,nil,nil,1000,1000)

       -- add a loadzone to CTLD
       my_ctld:AddCTLDZone("FARP "..FName,CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,true)
       local m  = MESSAGE:New(string.format("FARP %s in operation!",FName),15,"CTLD"):ToBlue() 
     end

     function my_ctld:OnAfterCratesBuild(From,Event,To,Group,Unit,Vehicle)
       local name = Vehicle:GetName()
       if string.find(name,"FOB",1,true) then
         local Coord = Vehicle:GetCoordinate()
         Vehicle:Destroy(false)
         BuildAFARP(Coord) 
       end
     end


local FarpFileName = "Foothold_SI_CTLD_FARPS.csv"

function SaveFARPS()
  local path = my_ctld.filepath
  local filename = FarpFileName
  local data = "FARP COORDINATES\n"
  
  for _,_coord in pairs(BuiltFARPCoordinates) do
    local FName = _coord.name -- This should now be the full name with "FAT COW" and frequency
    local coord = _coord.coord -- Core.Point#COORDINATE
    
    -- Debugging: Print FName to ensure it's the correct full name
    BASE:I("Searching for STATIC with name: " .. FName)
    
    local AFB = STATIC:FindByName(FName) -- This now correctly uses the full name
    
    if AFB and AFB:IsAlive() then
      local vec2 = coord:GetVec2() -- { x = self.x, y = self.z }
      data = data .. string.format("%f;%f;\n", vec2.x, vec2.y)
    end
  end
  
  if UTILS.SaveToFile(path, filename, data) then
    BASE:I("***** FARP Positions saved successfully!")
  else
    BASE:E("***** ERROR Saving FARP Positions!")
  end
end
 
function LoadFARPS()
  local path = my_ctld.filepath
  local filename = FarpFileName
  local okay,data = UTILS.LoadFromFile(path,filename)
  if okay then
    BASE:I("***** FARP Positions loaded successfully!")
    -- remove header
    table.remove(data, 1)
    for _,_entry in pairs(data) do
      local dataset = UTILS.Split(_entry,";")
      local x = tonumber(dataset[1])
      local y = tonumber(dataset[2])
      local coord = COORDINATE:NewFromVec2({x=x,y=y})
      BuildAFARP(coord)
    end
  else
    BASE:E("***** ERROR Loading FARP Positions!")
  end
end

local LoadFARPTimer = TIMER:New(LoadFARPS)
LoadFARPTimer:Start(5)

local SaveFARPTimer = TIMER:New(SaveFARPS)
SaveFARPTimer:Start(30,300)

-- Save Settings
my_ctld.enableLoadSave = true -- allow auto-saving and loading of files
    my_ctld.saveinterval = 600 -- save every 10 minutes
    my_ctld.filename = "FootHold_SI_CTLD_Save.csv" -- example filename
	my_ctld.filepath = lfs.writedir() .. "Missions\\Saves" -- example path
    my_ctld.eventoninject = true -- fire OnAfterCratesBuild and OnAfterTroopsDeployed events when loading (uses Inject functions)
    my_ctld.useprecisecoordloads = true -- Instead if slightly varyiing the group position, try to maintain it as is

my_ctld:__Load(10)

env.info("CTLD : is completed!")