env.info("Mission Setup : is loading.")

function merge(tbls)
	local res = {}
	for i,v in ipairs(tbls) do
		for i2,v2 in ipairs(v) do
			table.insert(res,v2)
		end
	end
	
	return res
end

function allExcept(tbls, except)
	local tomerge = {}
	for i,v in pairs(tbls) do
		if i~=except then
			table.insert(tomerge, v)
		end
	end
	return merge(tomerge)
end

upgrades = {
	redships = {
		blue = {'blueShip', 'blueShip', 'blueShip'},
		red = {'redShipS', 'redShipS-2', 'redShipS-1', 'redShipM', 'redShipM-1', 'redShipM-2', 'redShipL-1', 'redShipL', 'redShipL-2', 'redShipXL'}
	},
	blueships = {
		blue = {'blueShip'},
		red = {'redShipXL'}
	},
	airfield1 = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD1'},
		red = {'redInfantry1', 'redInfantry2', 'redArmor1', 'redArmor2', 'redPD1'}
	},
	airfield2 = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD1'},
		red = {'redInfantry1', 'redArmor1', 'redPD1', 'redPD2'}
	},
	airfield2hat = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD1'},
		red = {'FixedredInfantry1-1', 'redArmor1', 'redPD1', 'redPD2'}
	},
	airfield3 = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD2', 'blueHAWK'},
		red = {'redInfantry2', 'redArmor1', 'redArmor2', 'redPD2', 'redPD3'}
	},
	airfield6 = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD1', 'bluePATRIOT'},
		red = {'redInfantry2', 'redArmor1', 'redArmor2', 'redPD2', 'redPD3'}
	},
	airfield4 = {
		blue = {'blueInfantry','blueArmor', 'bluePD2'},
		red = {'redInfantry2', 'redArmor1', 'redArmor2', 'redPD3', 'redPD4'}
	},
	airfield4hurghada = {
		blue = {'blueInfantry','blueArmor', 'bluePD2', 'BLUE SAM Fixed Hurghada'},
		red = {'RED SAM Fixed Hurghada', 'Red SAM SHORAD Fixed Hurghada', 'redInfantry2', 'redArmor1'}
	},
	sam1 = {
        blue = {'bluePD1', 'bluePD1'},
        red = {'redPD1', 'redSA2'}
    },
	sam1bravo = {
        blue = {'bluePD1', 'BLUE SAM Fixed NASAMS Bravo'},
        red = {'Red SAM SHORAD Fixed Bravo', 'Red SAM Fixed SA-2 Bravo'}
    },
	sam1golf = {
        blue = {'bluePD1', 'BLUE SAM Fixed NASAMS Golf'},
        red = {'Red SAM SHORAD Fixed Golf', 'Red SAM Fixed SA-2 Golf'}
    },

	  sam2charlie = {
        blue = {'bluePD2', 'BLUE SAM FIXED NASAMS Charlie'},
        red = {'Red SAM SHORAD Fixed Charlie', 'Red SAM Fixed SA-3 Charlie'}
    },
	  sam2hotel = {
        blue = {'bluePD2', 'BLUE SAM Fixed NASAMS Hotel'},
        red = {'Red SAM SHORAD Fixed Hotel', 'Red SAM Fixed SA-3 Hotel'}
    },

	  sam3alpha = {
        blue = {'bluePD1', 'BLUE SAM Fixed Hawk Alpha'},
        red = {'Red SAM SHORAD Fixed Alpha', 'Red SAM Fixed SA-6 Alpha'}
    },
	 sam3delta = {
        blue = {'bluePD1', 'BLUE SAM Fixed HAWK Delta'},
        red = {'Red SAM SHORAD Fixed Delta', 'Red SAM Fixed SA-6 Delta'}
    },
	 sam3india = {
        blue = {'bluePD1', 'BLUE SAM Fixed HAWK India'},
        red = {'Red SAM SHORAD Fixed India', 'Red SAM Fixed SA-6 India'}
    },
    sam4juliett = {
        blue = {'bluePD2', 'BLUE SAM Fixed HAWK Juliett'},
        red = {'Red SAM SHORAD Fixed Juliett', 'Red SAM Fixed SA-10 Juliett'}
    },
    sam4lima = {
        blue = {'bluePD2', 'BLUE SAM Fixed HAWK Lima'},
        red = {'Red SAM SHORAD Fixed Lima', 'Red SAM Fixed SA-10 Lima'}
    },
    sam4echo = {
        blue = {'bluePD2', 'BLUE SAM Fixed HAWK Echo'},
        red = {'Red SAM SHORAD Fixed Echo', 'Red SAM Fixed SA-10 Echo'}
    },
    sam5kilo = {
        blue = {'bluePD1', 'BLUE SAM Fixed Patriot KILO'},
        red = {'Red SAM SHORAD Fixed Kilo', 'Red SAM Fixed SA-11 Kilo'}
    },
	 sam5missileFactory = {
        blue = {'bluePD1', 'bluePATRIOT'},
        red = {'Red SAM SHORAD Fixed Missile Factory', 'Red SAM Fixed SA-11 Missile Factory', 'Fixed-Scuds'}
    },
    sam5foxtrot = {
        blue = {'bluePD1', 'BLUE SAM Fixed PATRIOT Foxtrot'},
        red = {'Red SAM SHORAD Fixed Foxtrot', 'Red SAM Fixed SA-11 Foxtrot'}
    },
    sam6mike = {
        blue = {'bluePD2', 'FixedPatriot'},
        red = {'Red SAM SHORAD Fixed Mike', 'Red SAM Fixed SA-5 Mike'}
	},
	farp1 = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD1'},
		red = {'redInfantry1', 'redArmor1', 'redPD1'}
	},
	farp2 = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD1'},
		red = {'redInfantry1', 'redArmor1', 'redPD2'}
	},
	farp3 = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD2'},
		red = {'redInfantry2', 'redArmor2', 'redPD3'}
	},
	farp4 = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD2'},
		red = {'redInfantry2', 'redArmor2', 'redPD4'}
	},
	mission1 = {
		blue = {'blueInfantry', 'blueArmor'},
		red = {'Red SAM Fixed SA-3 Mining', 'Fixed Mining', 'Fixed Tripple A Mining', 'Red SAM SHORAD Fixed MiningFacility'}
	},
	
	mission1Ammo = {
		blue = {'blueInfantry', 'blueArmor'},
		red = {'Fixed-ammo1', 'Fixed-ammo4-1', 'Fixed-ammo3', 'Fixed-ammo4', 'Fixed-ammo2', 'Fixed-ammo4-2'}
	},
	
	mission2 = {
		blue = {'blueInfantry', 'blueArmor'},
		red = {'Fixed-Tanks', 'Fixed-SA6tankfactroy2', 'Fixed-SA6tankfactroy', 'Fixed-Tanks-3'}
	},
	mission2InsurgentCamp = {
		blue = {'blueInfantry', 'blueArmor'},
		red = {'Fixed-InfantryGroup', 'Fixed-InfantryGroup-2', 'Fixed-Zu23', 'Fixed-Art'}
	
	},
	mission3 = {
		blue = {'blueInfantry', 'blueArmor'},
		red = {'Red SAM Fixed SA-6 Secret tech', 'Red SAM SHORAD Fixed Secret tech', 'Fixed-redArmor2', 'Fixed-redArmor1', 'Fixed-redInfantry2'}
			  
	},
	mission3chemsite = {
		blue = {'blueInfantry', 'blueArmor'},
		red = {'Fixed-redInfantry2-1', 'Fixed-redArmor1-1', 'Fixed-redArmor2-1', 'Fixed-redPD3-1'}
	},
	mission4 = {
		blue = {'blueInfantry', 'blueArmor'},
		red = {'redInfantry2', 'redArmor1', 'redArmor2', 'redPD4'}
	},
	
	mission4fueldepo = {
		blue = {'blueInfantry', 'blueArmor'},
		red = {'Fixed-Fuel2', 'Fixed-Fuel5', 'Fixed-Fuel4', 'Fixed-Fuel'}
	}
}

flavor = {
	redcarrier = 'Enemy carrier zone',
	bluecarrier = 'WPT \nStart zone',
	
	sdedov = 'WPT \n',
	bengurion = 'WPT 1\n',
	palmahim = 'WPT \n',
	telnof = 'WPT \n',
	hatzor = 'WPT 2\n',
	kedemhatzerim = 'WPT 3\n',
	nevatim = 'WPT 4\n',
	ramonairbase = 'WPT 5\n',
	elgora = 'WPT 6\n',
	elarish = 'WPT 7\n',
	ovda = 'WPT 10\n',
	stcatherine = 'WPT 14\n',
	sharmelsheikh = 'WPT 15\n',
	hurghada = 'WPT 16\n',
	aburudeis = 'WPT 21\n',
	birhasanah = 'WPT 25\n',
	melez = 'WPT 26\n',
	baluza = 'WPT 28\n',
	assalihiyah = 'WPT 31\n',
	alismailiyah = 'WPT 33\n',
	abusuwayr = 'WPT 32\n', 
	difarsuwarairfield = 'WPT 34\n',
	fayed = 'WPT 35\n',
	kibritairbase = 'WPT 36\n',
	almansurah = 'WPT 30\n',
	azzaqaziq = 'WPT 43\n',
	bilbeisairbase = 'WPT 42\n',
	inshasairbase = 'WPT 41\n',
	cairointernationalairport = 'WPT 40\n',
	wadialjandali = 'WPT 37\n',
	cairowest = 'WPT 45\n',
	benisuef = 'WPT 38\n',
	Quwaysina= 'WPT 44\n',
	komawshim= 'WPT 39\n',
	birmaairbase= 'WPT 46\n',
	
	
	farpalpha = 'WPT 9\n',
	farpbravo = 'WPT 10\n',
	farpcharlie = 'WPT 12\n',
	farpdelta = 'WPT 13\n',
	farpecho = 'WPT 17\n',
	farpfoxtrot = 'WPT 18\n',
	farpgolf = 'WPT 19\n',
	farphotel = 'WPT 20\n',
	farpindia = 'WPT 22\n',
	farpjuliett = 'WPT 23\n',
	farpkilo = 'WPT 8\n', 
	farplima= 'WPT 27\n',
	farpmike= 'WPT 24\n',
	
	
	miningfacility = 'WPT \n',
	insurgentcamp = 'WPT \nDestroy the Insurgents and we will add to your bank 500 credits',
	secrettechfacility = 'WPT \nDestroy the buildings and area completly',
	fueldepo = 'WPT \nTake out their Fuel Depo including the fuel tanks',
	ammonitiondepo = 'WPT \nTake out their ammunition Depo including the storage',
	tankfactory = 'WPT \nDestroy the factorys and the tank storage',
	chemsite = 'WPT \nHere they are building chemical weapons. Destroy the buildings',
	artilleryfactory = 'WPT \n',
	missilefactory = 'WPT \nRumors say they have Scuds here',
	
	samalpha = 'WPT \n',
	sambravo = 'WPT \n',
	samcharlie = 'WPT \n',
	samdelta = 'WPT \n',
	samecho = 'WPT \nSA-10',
	samfoxtrot = 'WPT \nSA-11',
	samgolf = 'WPT \nSA-2',
	samhotel = 'WPT \nSA-3',
	samindia = 'WPT \nSA-6',
	samjuliett = 'WPT \nSA-10',
	samkilo = 'WPT \nSA-10',
	samlima = 'WPT \nSA-10',
	sammike = 'WPT \nSA-5'
}
local filepath = 'FootHold_SI_v0.3.lua'
if lfs then 
	local dir = lfs.writedir()..'Missions/Saves/'
	lfs.mkdir(dir)
	filepath = dir..filepath
	env.info('Foothold - Save file path: '..filepath)
end
bc = BattleCommander:new(filepath, 10, 60)
zones = {
	redcarrier = ZoneCommander:new({zone='Red Carrier', side=1, level=10, upgrades=upgrades.redships, crates={}, flavorText=flavor.redcarrier}),
	bluecarrier = ZoneCommander:new({zone='Blue Carrier', side=2, level=1, upgrades=upgrades.blueships, crates={}, flavorText=flavor.bluecarrier}),
	
	sdedov = ZoneCommander:new({zone='Sde Dov', side=2, level=2, upgrades=upgrades.airfield1, crates={}, flavorText=flavor.sdedov}),
	bengurion = ZoneCommander:new({zone='Ben-Gurion', side=2, level=1, upgrades=upgrades.airfield2, crates={}, flavorText=flavor.bengurion}),
	palmahim = ZoneCommander:new({zone='Palmahim', side=2, level=1, upgrades=upgrades.airfield3, crates={}, flavorText=flavor.palmahim}),
	telnof = ZoneCommander:new({zone='Tel Nof', side=2, level=1, upgrades=upgrades.airfield4, crates={}, flavorText=flavor.telnof}),
	hatzor = ZoneCommander:new({zone='Hatzor', side=2, level=1, upgrades=upgrades.airfield1, crates={}, flavorText=flavor.hatzor}),
	kedemhatzerim = ZoneCommander:new({zone='Kedem-Hatzerim', side=1, level=5, upgrades=upgrades.airfield2hat, crates={}, flavorText=flavor.kedemhatzerim}),
	nevatim = ZoneCommander:new({zone='Nevatim', side=1, level=5, upgrades=upgrades.airfield3, crates={}, flavorText=flavor.nevatim}),
	ramonairbase = ZoneCommander:new({zone='Ramon Airbase', side=1, level=5, upgrades=upgrades.airfield4, crates={}, flavorText=flavor.ramonairbase}),
	elgora = ZoneCommander:new({zone='El Gora', side=1, level=3, upgrades=upgrades.airfield1, crates={}, flavorText=flavor.elgora}),
	elarish = ZoneCommander:new({zone='El Arish', side=1, level=3, upgrades=upgrades.airfield2, crates={}, flavorText=flavor.elarish}),
	ovda = ZoneCommander:new({zone='Ovda', side=1, level=3, upgrades=upgrades.airfield3, crates={}, flavorText=flavor.ovda}),
	stcatherine = ZoneCommander:new({zone='St Catherine', side=1, level=2, upgrades=upgrades.airfield4, crates={}, flavorText=flavor.stcatherine}),
	sharmelsheikh = ZoneCommander:new({zone='Sharm El Sheikh International Airport', side=0, level=3, upgrades=upgrades.airfield4, crates={}, flavorText=flavor.sharmelsheikh, NeutralAtStart=true, firstCaptureByRed = false}),
	hurghada = ZoneCommander:new({zone='Hurghada International Airport', side=0, level=2, upgrades=upgrades.airfield4hurghada, crates={}, flavorText=flavor.hurghada, NeutralAtStart=true, firstCaptureByRed = false}),
	aburudeis = ZoneCommander:new({zone='Abu Rudeis', side=1, level=1, upgrades=upgrades.airfield1, crates={}, flavorText=flavor.aburudeis}),
	birhasanah = ZoneCommander:new({zone='Bir Hasanah', side=0, level=2, upgrades=upgrades.airfield2, crates={}, flavorText=flavor.birhasanah, NeutralAtStart=true, firstCaptureByRed = false}),
	melez = ZoneCommander:new({zone='Melez', side=1, level=5, upgrades=upgrades.airfield6, crates={}, flavorText=flavor.melez}),
	baluza = ZoneCommander:new({zone='Baluza', side=0, level=2, upgrades=upgrades.airfield4, crates={}, flavorText=flavor.baluza, NeutralAtStart=true}),
	assalihiyah = ZoneCommander:new({zone='As Salihiyah', side=0, level=2, upgrades=upgrades.airfield1, crates={}, flavorText=flavor.assalihiyah, NeutralAtStart=true, firstCaptureByRed = false}),
	alismailiyah = ZoneCommander:new({zone='Al Ismailiyah', side=1, level=2, upgrades=upgrades.airfield2, crates={}, flavorText=flavor.alismailiyah}),
	abusuwayr = ZoneCommander:new({zone='Abu Suwayr', side=0, level=2, upgrades=upgrades.airfield3, crates={}, flavorText=flavor.abusuwayr, NeutralAtStart=true}),
	difarsuwarairfield = ZoneCommander:new({zone='Difarsuwar Airfield', side=0, level=1, upgrades=upgrades.airfield4, crates={}, flavorText=flavor.difarsuwarairfield, NeutralAtStart=true, firstCaptureByRed = false}),
	fayed = ZoneCommander:new({zone='Fayed', side=0, level=2, upgrades=upgrades.airfield1, crates={}, flavorText=flavor.fayed, NeutralAtStart=true, firstCaptureByRed = false}),
	kibritairbase = ZoneCommander:new({zone='Kibrit Air Base', side=1, level=1, upgrades=upgrades.airfield2, crates={}, flavorText=flavor.kibritairbase}),
	almansurah = ZoneCommander:new({zone='Al Mansurah', side=0, level=1, upgrades=upgrades.airfield3, crates={}, flavorText=flavor.almansurah, NeutralAtStart=true, firstCaptureByRed = false}),
	azzaqaziq = ZoneCommander:new({zone='AzZaqaziq', side=0, level=1, upgrades=upgrades.airfield4, crates={}, flavorText=flavor.azzaqaziq, NeutralAtStart=true, firstCaptureByRed = false}),
	bilbeisairbase = ZoneCommander:new({zone='Bilbeis Air Base', side=0, level=1, upgrades=upgrades.airfield1, crates={}, flavorText=flavor.bilbeisairbase, NeutralAtStart=true, firstCaptureByRed = false}),
	inshasairbase = ZoneCommander:new({zone='Inshas Airbase', side=0, level=1, upgrades=upgrades.airfield2, crates={}, flavorText=flavor.inshasairbase, NeutralAtStart=true, firstCaptureByRed = false}),
	cairointernationalairport = ZoneCommander:new({zone='Cairo International Airport', side=0, level=1, upgrades=upgrades.airfield3, crates={}, flavorText=flavor.cairointernationalairport, NeutralAtStart=true, firstCaptureByRed = false}),
	wadialjandali = ZoneCommander:new({zone='Wadi al Jandali', side=0, level=1, upgrades=upgrades.airfield4, crates={}, flavorText=flavor.wadialjandali, NeutralAtStart=true, firstCaptureByRed = false}),
	cairowest = ZoneCommander:new({zone='Cairo West', side=0, level=1, upgrades=upgrades.airfield4, crates={}, flavorText=flavor.cairowest, NeutralAtStart=true, firstCaptureByRed = false}),
	benisuef = ZoneCommander:new({zone='Beni Suef', side=0, level=1, upgrades=upgrades.airfield4, crates={}, flavorText=flavor.benisuef, NeutralAtStart=true, firstCaptureByRed = false}),
	komawshim = ZoneCommander:new({zone='Kom Awshim', side=0, level=1, upgrades=upgrades.farp2, crates={}, flavorText=flavor.komawshim, NeutralAtStart=true, firstCaptureByRed = false}),
	quwaysina = ZoneCommander:new({zone='Quwaysina', side=0, level=1, upgrades=upgrades.farp3, crates={}, flavorText=flavor.quwaysina, NeutralAtStart=true, firstCaptureByRed = false}),
	birmaairbase = ZoneCommander:new({zone='Birma Air Base', side=0, level=1, upgrades=upgrades.farp3, crates={}, flavorText=flavor.birmaairbase, NeutralAtStart=true, firstCaptureByRed = false}),
	
	farpalpha = ZoneCommander:new({zone='FARP-Alpha', side=1, level=3, upgrades=upgrades.farp1, crates={}, flavorText=flavor.farpalpha}),
	farpbravo = ZoneCommander:new({zone='FARP-Bravo', side=1, level=3, upgrades=upgrades.farp2, crates={}, flavorText=flavor.farpbravo}),
	farpcharlie = ZoneCommander:new({zone='FARP-Charlie', side=0, level=2, upgrades=upgrades.farp3, crates={}, flavorText=flavor.farpcharlie, NeutralAtStart=true, firstCaptureByRed = false}),
	farpdelta = ZoneCommander:new({zone='FARP-Delta', side=0, level=2, upgrades=upgrades.farp4, crates={}, flavorText=flavor.farpdelta, NeutralAtStart=true, firstCaptureByRed = false}), --,income=0.5
	farpecho = ZoneCommander:new({zone='FARP-Echo', side=0, level=2, upgrades=upgrades.farp1, crates={}, flavorText=flavor.farpecho, NeutralAtStart=true, firstCaptureByRed = false}),
	farpfoxtrot = ZoneCommander:new({zone='FARP-Foxtrot', side=0, level=1, upgrades=upgrades.farp2, crates={}, flavorText=flavor.farpfoxtrot, NeutralAtStart=true, firstCaptureByRed = false}),
	farpgolf = ZoneCommander:new({zone='FARP-Golf', side=0, level=1, upgrades=upgrades.farp3, crates={}, flavorText=flavor.farpgolf, NeutralAtStart=true, firstCaptureByRed = false}),
	farphotel = ZoneCommander:new({zone='FARP-Hotel', side=0, level=1, upgrades=upgrades.farp4, crates={}, flavorText=flavor.farphotel, NeutralAtStart=true, firstCaptureByRed = false}),
	farpindia = ZoneCommander:new({zone='FARP-India', side=0, level=1, upgrades=upgrades.farp1, crates={}, flavorText=flavor.farpindia, NeutralAtStart=true, firstCaptureByRed = false}),
	farpjuliett = ZoneCommander:new({zone='FARP-Juliett', side=0, level=1, upgrades=upgrades.farp2, crates={}, flavorText=flavor.farpjuliett, NeutralAtStart=true, firstCaptureByRed = false}),
	farpkilo = ZoneCommander:new({zone='FARP-Kilo', side=0, level=3, upgrades=upgrades.farp3, crates={}, flavorText=flavor.farpkilo, NeutralAtStart=true, firstCaptureByRed = false}),
	farplima = ZoneCommander:new({zone='FARP-Lima', side=0, level=3, upgrades=upgrades.farp4, crates={}, flavorText=flavor.farplima, NeutralAtStart=true, firstCaptureByRed = false}),
	farpmike = ZoneCommander:new({zone='FARP-Mike', side=1, level=3, upgrades=upgrades.farp1, crates={}, flavorText=flavor.farpmike}),
	
	
	miningfacility = ZoneCommander:new({zone='MiningFacility', side=1, level=4, upgrades=upgrades.mission1, crates={}, flavorText=flavor.miningfacility}),
	insurgentcamp = ZoneCommander:new({zone='InsurgentCamp', side=1, level=4, upgrades=upgrades.mission2InsurgentCamp, crates={}, flavorText=flavor.insurgentcamp}),
	secrettechfacility = ZoneCommander:new({zone='SecretTechFacility', side=1, level=6, upgrades=upgrades.mission3, crates={}, flavorText=flavor.secrettechfacility}),
	fueldepo = ZoneCommander:new({zone='FuelDepo', side=1, level=4, upgrades=upgrades.mission4fueldepo, crates={}, flavorText=flavor.fueldepo}),
	ammonitiondepo = ZoneCommander:new({zone='AmmonitionDepo', side=1, level=6, upgrades=upgrades.mission1Ammo, crates={}, flavorText=flavor.ammonitiondepo}),
	tankfactory = ZoneCommander:new({zone='TankFactory', side=1, level=4, upgrades=upgrades.mission2, crates={}, flavorText=flavor.tankfactory}),
	chemsite = ZoneCommander:new({zone='ChemSite', side=1, level=4, upgrades=upgrades.mission3chemsite, crates={}, flavorText=flavor.chemsite}),
	artilleryfactory = ZoneCommander:new({zone='ArtilleryFactory', side=1, level=4, upgrades=upgrades.mission4, crates={}, flavorText=flavor.artilleryfactory}),
	missilefactory = ZoneCommander:new({zone='MissileFactory', side=1, level=4, upgrades=upgrades.sam5missileFactory, crates={}, flavorText=flavor.missilefactory}),
	
	samalpha = ZoneCommander:new({zone='SAM-Alpha', side=2, level=2, upgrades=upgrades.sam3alpha, crates={}, flavorText=flavor.samalpha}),
	sambravo = ZoneCommander:new({zone='SAM-Bravo', side=1, level=2, upgrades=upgrades.sam1bravo, crates={}, flavorText=flavor.sambravo}),
	samcharlie = ZoneCommander:new({zone='SAM-Charlie', side=1, level=2, upgrades=upgrades.sam2charlie, crates={}, flavorText=flavor.samcharlie}),
	samdelta = ZoneCommander:new({zone='SAM-Delta', side=1, level=2, upgrades=upgrades.sam3delta, crates={}, flavorText=flavor.samdelta}),
	samecho = ZoneCommander:new({zone='SAM-Echo', side=1, level=2, upgrades=upgrades.sam4echo, crates={}, flavorText=flavor.samecho}),
	samfoxtrot = ZoneCommander:new({zone='SAM-Foxtrot', side=1, level=2, upgrades=upgrades.sam5foxtrot, crates={}, flavorText=flavor.samfoxtrot}),
	samgolf = ZoneCommander:new({zone='SAM-Golf', side=1, level=2, upgrades=upgrades.sam1golf, crates={}, flavorText=flavor.samgolf}),
	samhotel = ZoneCommander:new({zone='SAM-Hotel', side=1, level=2, upgrades=upgrades.sam2hotel, crates={}, flavorText=flavor.samhotel}),
	samindia = ZoneCommander:new({zone='SAM-India', side=1, level=2, upgrades=upgrades.sam3india, crates={}, flavorText=flavor.samindia}),
	samjuliett = ZoneCommander:new({zone='SAM-Juliett', side=1, level=2, upgrades=upgrades.sam4juliett, crates={}, flavorText=flavor.samjuliett}),
	samkilo = ZoneCommander:new({zone='SAM-Kilo', side=1, level=2, upgrades=upgrades.sam5kilo, crates={}, flavorText=flavor.samkilo}),
	samlima = ZoneCommander:new({zone='SAM-Lima', side=1, level=2, upgrades=upgrades.sam4lima, crates={}, flavorText=flavor.samlima}),
	sammike = ZoneCommander:new({zone='SAM-Mike', side=1, level=2, upgrades=upgrades.sam6mike, crates={}, flavorText=flavor.sammike})
}

zones.hatzor:addGroups({
    GroupCommander:new({name = 'Hatzor-Attack-Kedem-blue', mission = 'attack', targetzone = 'Kedem-Hatzerim'}),
    GroupCommander:new({name = 'Hatzor-Support-Kedem-blue', mission = 'supply', targetzone = 'Kedem-Hatzerim'}),
    GroupCommander:new({name = 'Hatzor-Support-SAM-Alpha-blue', mission = 'supply', targetzone = 'SAM-Alpha'})
})

zones.elgora:addGroups({
    GroupCommander:new({name = 'El-Gora-Support-El-Arish-blue', mission = 'supply', targetzone = 'El Arish'})
})

zones.farpalpha:addGroups({
    GroupCommander:new({name = 'Farp-Alpha-Supply-Farp-Kilo-blue', mission = 'supply', targetzone = 'FARP-Kilo'}),
    GroupCommander:new({name = 'Farp-Alpha-Supply-Ovda-blue', mission = 'supply', targetzone = 'Ovda'})
})

zones.farpdelta:addGroups({
    GroupCommander:new({name = 'FARP-Delta-supply-St-Catherine', mission = 'supply', targetzone = 'St Catherine', condition = function() return zones.ovda.side == 2 or zones.ovda.wasBlue end}),
    GroupCommander:new({name = 'FARP-Delta-supply-St-Catherine-Blue', mission = 'supply', targetzone = 'St Catherine', condition = function() return zones.ovda.side == 2 or zones.ovda.wasBlue end}),
    GroupCommander:new({name = 'FARP-Delta-supply-Sharm-el-sheikh-Blue', mission = 'supply', targetzone = 'Sharm El Sheikh International Airport', condition = function() return zones.ovda.side == 2 or zones.ovda.wasBlue end}),
    GroupCommander:new({name = 'FARP-Delta-supply-Sharm-el-sheikh', mission = 'supply', targetzone = 'Sharm El Sheikh International Airport', condition = function() return zones.ovda.side == 2 or zones.ovda.wasBlue end})
})

zones.farpcharlie:addGroups({
    GroupCommander:new({name = 'FARP-Charlie-supply-St-Catherine', mission = 'supply', targetzone = 'St Catherine', condition = function() return zones.ovda.side == 2 or zones.ovda.wasBlue end}),
    GroupCommander:new({name = 'FARP-Charlie-supply-St-Catherine-Blue', mission = 'supply', targetzone = 'St Catherine', condition = function() return zones.ovda.side == 2 or zones.ovda.wasBlue end}),
    GroupCommander:new({name = 'FARP-Charlie-supply-FARP-Delta-Blue', mission = 'supply', targetzone = 'FARP-Delta', condition = function() return zones.ovda.side == 2 or zones.ovda.wasBlue end}),
    GroupCommander:new({name = 'FARP-Charlie-supply-FARP-Delta', mission = 'supply', targetzone = 'FARP-Delta', condition = function() return zones.ovda.side == 2 or zones.ovda.wasBlue end})
})

zones.farplima:addGroups({
    GroupCommander:new({name = 'Farp-Lima-Supply-Baluza-blue', mission = 'supply', targetzone = 'Baluza'}),
    GroupCommander:new({name = 'Farp-Lima-Supply-Melez-blue', mission = 'supply', targetzone = 'Melez'}),
    GroupCommander:new({name = 'Farp-Lima-supply-Melez', mission = 'supply', targetzone = 'Melez', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end})
})

zones.kedemhatzerim:addGroups({
	GroupCommander:new({name = 'Kedem-Support-Nevatim-blue', mission = 'supply', targetzone = 'Nevatim'}),
	GroupCommander:new({name = 'Kadem-supprt-Ramon-blue', mission = 'supply', targetzone = 'Ramon Airbase'}),
    GroupCommander:new({name = 'Kedem-Support-El Gora-blue', mission = 'supply', targetzone = 'El Gora'}),
    GroupCommander:new({name = 'Kadem-supprt-Nevatim-blue', mission = 'supply', targetzone = 'Nevatim'}),
	GroupCommander:new({name = 'Kedem-Support-Ramon-blue', mission = 'supply', targetzone = 'Ramon Airbase'}),
    GroupCommander:new({name = 'Hatzerim-Attack-Hatzor', mission = 'attack', targetzone = 'Hatzor'}),
    GroupCommander:new({name = 'Hatzerim-Support-Hatzor', mission = 'supply', targetzone = 'Hatzor'})
    
    
})

zones.birhasanah:addGroups({
    GroupCommander:new({name = 'Bir-Hasanah-Support-SAM-Foxtrot-Blue', mission = 'supply', targetzone = 'SAM-Foxtrot'})
})

zones.ramonairbase:addGroups({
    GroupCommander:new({name = 'Ramon-Attack-Hatzor', mission = 'attack', targetzone = 'Hatzor', condition = function() return zones.melez.side == 1 end}),
    GroupCommander:new({name = 'Ramon-Attack-Kedem', mission = 'attack', targetzone = 'Kedem-Hatzerim', condition = function() return zones.melez.side == 1 end}),
    GroupCommander:new({name = 'Ramon-Supply-Kedem', mission = 'supply', targetzone = 'Kedem-Hatzerim', condition = function() return zones.melez.side == 1 end}),
    GroupCommander:new({name = 'Ramon-Supply-Nevatim', mission = 'supply', targetzone = 'Nevatim', condition = function() return zones.melez.side == 1 end}),
    GroupCommander:new({name = 'Ramon-Supply-El Gora', mission = 'supply', targetzone = 'El Gora', condition = function() return zones.melez.side == 1 end}),
    GroupCommander:new({name = 'Ramon-Supply-SAM-Bravo', mission = 'supply', targetzone = 'SAM-Bravo', condition = function() return zones.melez.side == 1 end}),
    GroupCommander:new({name = 'Ramon-Patrol-Kedem', mission = 'patrol', targetzone = 'Kedem-Hatzerim', condition = function() return zones.melez.side == 1 end}),
    GroupCommander:new({name = 'Ramon-Patrol-Kedem', mission = 'patrol', targetzone = 'Nevatim', condition = function() return zones.melez.side == 1 end}),
    GroupCommander:new({name = 'Ramon-Supply-Sam-Bravo-blue', mission = 'supply', targetzone = 'SAM-Bravo'}),
    GroupCommander:new({name = 'Ramon-Attack-Melez-blue', mission = 'attack', targetzone = 'Melez'}),
    GroupCommander:new({name = 'Ramon-Supply-Farp-Alpha-blue', mission = 'supply', targetzone = 'FARP-Alpha'}),
    GroupCommander:new({name = 'Ramon-Supply-El-Gora-blue', mission = 'supply', targetzone = 'El Gora'}),
    GroupCommander:new({name = 'Ramon-Patrol-Melez-Blue', mission = 'attack', targetzone = 'Melez'}),
	GroupCommander:new({name = 'Ramon-Patrol-Ovda-blue', mission = 'attack', targetzone = 'Ovda'})
})

zones.ovda:addGroups({
    GroupCommander:new({name = 'Ovda-Attack-Kedem', mission = 'attack', targetzone = 'Ramon Airbase'}),
    GroupCommander:new({name = 'Ovda-Support-Ramon', mission = 'supply', targetzone = 'Ramon Airbase'}),
    GroupCommander:new({name = 'Ovda-Support-FARP-Alpha', mission = 'supply', targetzone = 'FARP-Alpha'}),
    GroupCommander:new({name = 'Ovda-Patrol-Catherine-blue', mission = 'patrol', targetzone = 'St Catherine'}),
    GroupCommander:new({name = 'Ovda-Supply-Farp-Bravo-blue', mission = 'supply', targetzone = 'FARP-Bravo'}),
    GroupCommander:new({name = 'Ovda-Patrol-Ramon-Airbase', mission = 'patrol', targetzone = 'Ramon Airbase'})
})

zones.melez:addGroups({
	GroupCommander:new({name = 'Melez-Support-Bir-Hasanah', mission = 'supply', targetzone = 'Bir hasanah', type = 'surface', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end}),
	GroupCommander:new({name = 'Melez-Support-Sam-Golf', mission = 'supply', targetzone = 'SAM-Golf', type = 'surface', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end}),
	GroupCommander:new({name = 'Melez-Support-Nevrim', mission = 'supply', targetzone = 'Nevatim'}),
    GroupCommander:new({name = 'Melez-Support-Bir Hasanah', mission = 'supply', targetzone = 'Bir Hasanah', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end}),
    GroupCommander:new({name = 'Melez-Support-FARP-Kilo', mission = 'supply', targetzone = 'FARP-Kilo', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end}),
    GroupCommander:new({name = 'Melez-Support-FARP-Lima', mission = 'supply', targetzone = 'FARP-Lima', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end, urgent = zones.farplima.side == 0}),
    GroupCommander:new({name = 'Melez-Attack-Bir Hasanah', mission = 'attack', targetzone = 'Bir Hasanah', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end}),
    GroupCommander:new({name = 'Melez-Attack-FARP-Kilo', mission = 'attack', targetzone = 'FARP-Kilo', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end}),
    GroupCommander:new({name = 'Melez-Attack-FARP-Lima', mission = 'attack', targetzone = 'FARP-Lima', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end}),
    GroupCommander:new({name = 'Melez-Patrol-Bir Hasanah', mission = 'patrol', targetzone = 'Bir Hasanah', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end}),
    GroupCommander:new({name = 'Melez-Attack-ramon-air-base', mission = 'attack', targetzone = 'Ramon Airbase', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end}),
	GroupCommander:new({name = 'Melez-support-Bir-Hasanah-Blue', mission = 'supply', targetzone = 'Bir Hasanah'}),
    GroupCommander:new({name = 'Melez-support-FARP-Kilo-blue', mission = 'supply', targetzone = 'FARP-Kilo'}),
    GroupCommander:new({name = 'Melez-Support-Sam-Golf-blue', mission = 'supply', targetzone = 'SAM-Golf', type = 'surface'}),
    GroupCommander:new({name = 'Melez-Support-Difarsuwar Airfield-blue', mission = 'supply', targetzone = 'Difarsuwar Airfield', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end}),
    GroupCommander:new({name = 'Melez-Support-Al Ismailiyah-blue', mission = 'supply', targetzone = 'Al Ismailiyah'}),
	GroupCommander:new({name = 'Melez-Support-FARP-Lima-Blue', mission = 'supply', targetzone = 'FARP-Lima'}),
	GroupCommander:new({name = 'Melez-support-FARP-kibrit-air-base-blue', mission = 'supply', targetzone = 'Kibrit Air Base'}),
	GroupCommander:new({name = 'Melez-patrol-Melez-blue', mission = 'patrol', targetzone = ' Melez'})
	
	
	
})

zones.baluza:addGroups({
    GroupCommander:new({name = 'Baluza-Support-SAM-Hotel', mission = 'supply', targetzone = 'SAM-Hotel', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end}),
    GroupCommander:new({name = 'Baluza-Support-Melez', mission = 'supply', targetzone = 'Melez', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end}),
    GroupCommander:new({name = 'Baluza-Support-FARP-Lima', mission = 'supply', targetzone = 'FARP-Lima', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end}),
    GroupCommander:new({name = 'Baluza-Attack-El Arish', mission = 'attack', targetzone = 'El Arish', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end}),
    GroupCommander:new({name = 'Baluza-Attack-Melez', mission = 'attack', targetzone = 'Melez', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end}),
    GroupCommander:new({name = 'Baluza-Support-As-Salihiyah-blue', mission = 'supply', targetzone = 'As Salihiyah'}),
	GroupCommander:new({name = 'Baluza-Support-SAM-Hotel-blue', mission = 'supply', targetzone = 'SAM-Hotel'})
})

zones.stcatherine:addGroups({
    GroupCommander:new({name = 'Catherine-Attack-Ovda', mission = 'attack', targetzone = 'Ovda'}),
    GroupCommander:new({name = 'Catherine-Patrol-Ovda', mission = 'patrol', targetzone = 'Ovda'}),
    GroupCommander:new({name = 'Catherine-Supply-SAM-Charlie', mission = 'supply', targetzone = 'SAM-Charlie', condition = function() return zones.ovda.side == 2 or zones.ovda.wasBlue end}),
    GroupCommander:new({name = 'Catherine-Supply-FARP-Bravo', mission = 'supply', targetzone = 'FARP-Bravo', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end}),
    GroupCommander:new({name = 'Catherine-Supply-FARP-Charlie', mission = 'supply', targetzone = 'FARP-Charlie', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end, urgent = zones.farpcharlie.side == 0}),
    GroupCommander:new({name = 'Catherine-Supply-FARP-Delta', mission = 'supply', targetzone = 'FARP-Delta', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end, urgent = zones.farpdelta.side == 0}),
    GroupCommander:new({name = 'Catherine-Supply-FARP-Charlie-Blue', mission = 'supply', targetzone = 'FARP-Charlie'}),
    GroupCommander:new({name = 'Catherine-Supply-FARP-Delta-Blue', mission = 'supply', targetzone = 'FARP-Delta'}),
    GroupCommander:new({name = 'Catherine-Supply-FARP-Echo-Blue', mission = 'supply', targetzone = 'FARP-Echo'}),
    GroupCommander:new({name = 'Catherine-Supply-FARP-Golf-Blue', mission = 'supply', targetzone = 'FARP-Golf'}),
    GroupCommander:new({name = 'Catherine-Supply-FARP-Foxtrot-Blue', mission = 'supply', targetzone = 'FARP-Foxtrot'}),
    GroupCommander:new({name = 'Catherine-Supply-FARP-Hotel-Blue', mission = 'supply', targetzone = 'FARP-Hotel'}),
    GroupCommander:new({name = 'Catherine-Supply-Abu-Rudeis-Blue', mission = 'supply', targetzone = 'Abu Rudeis'}),
    GroupCommander:new({name = 'Catherine-Supply-SAM-Charlie-Blue', mission = 'supply', targetzone = 'SAM-Charlie'}), 
    GroupCommander:new({name = 'Catherine-Patrol-Catherine', mission = 'attack', targetzone = 'Ovda', condition = function() return zones.ovda.side == 2 end}),
	GroupCommander:new({name = 'Catherine-supply-Sharm-El-Sheikh', mission = 'supply', targetzone = 'Sharm El Sheikh International Airport', condition = function() return zones.ovda.side == 2 or zones.ovda.wasBlue end}),
	GroupCommander:new({name = 'Catherine-Supply-Farp-Echo', mission = 'supply', targetzone = 'FARP-Echo', condition = function() return zones.ovda.side == 2 or zones.ovda.wasBlue end, urgent = zones.farpecho.side == 0}),
	GroupCommander:new({name = 'Catherine-Support-FARP-Foxtrot', mission = 'supply', targetzone = 'FARP-Foxtrot', condition = function() return zones.ovda.side == 2 or zones.ovda.wasBlue end, urgent = zones.farpfoxtrot.side == 0})
})

zones.sharmelsheikh:addGroups({
    GroupCommander:new({name = 'Sharm-el-sheikh-Supply-Hurghada', mission = 'supply', targetzone = 'Hurghada International Airport', condition = function() return zones.ovda.side == 2 or zones.ovda.wasBlue end}),
    GroupCommander:new({name = 'Sharm-el-sheikh-Supply-Hurghada-Blue', mission = 'supply', targetzone = 'Hurghada International Airport'}),
    GroupCommander:new({name = 'Sharm-el-sheikh-Supply-FARP-Echo', mission = 'supply', targetzone = 'FARP-Echo', condition = function() return zones.ovda.side == 2 or zones.ovda.wasBlue end}),
    GroupCommander:new({name = 'Sharm-el-sheikh-Supply-FARP-Echo-Blue', mission = 'supply', targetzone = 'FARP-Echo'}),
    GroupCommander:new({name = 'Sharm-el-sheikh-Supply-chathrine', mission = 'supply', targetzone = 'St Catherine', condition = function() return zones.ovda.side == 2 or zones.ovda.wasBlue end})
})


zones.aburudeis:addGroups({
	GroupCommander:new({name = 'AbuRudeis-Supply-FARP-India-blue', mission = 'supply', targetzone = 'FARP-India'}),
	GroupCommander:new({name = 'AbuRudeis-Supply-SAM-Echo-blue', mission = 'supply', targetzone = 'SAM-Echo'}),
	GroupCommander:new({name = 'AbuRudeis-Supply-FARP-Juliett-blue', mission = 'supply', targetzone = 'FARP-Juliett'}),
    GroupCommander:new({name = 'AbuRudis-Attack-Catherine', mission = 'attack', targetzone = 'St Catherine', condition = function() return zones.ovda.side == 2 or zones.ovda.wasBlue end}),
    GroupCommander:new({name = 'AbuRudis-Attack-FARP-Golf', mission = 'attack', targetzone = 'FARP-Golf', condition = function() return zones.ovda.side == 2 or zones.ovda.wasBlue end}),
    GroupCommander:new({name = 'AbuRudis-Attack-FARP-Hotel', mission = 'attack', targetzone = 'FARP-Hotel', condition = function() return zones.ovda.side == 2 or zones.ovda.wasBlue end}),
    GroupCommander:new({name = 'AbuRudis-Attack-FARP-Foxtrot', mission = 'attack', targetzone = 'FARP-Foxtrot', condition = function() return zones.ovda.side == 2 or zones.ovda.wasBlue end}),
    GroupCommander:new({name = 'AbuRudis-Patrol-Catherine', mission = 'patrol', targetzone = 'St Catherine', condition = function() return zones.ovda.side == 2 or zones.ovda.wasBlue end}),
    GroupCommander:new({name = 'AbuRudis-Support-Catherine', mission = 'supply', targetzone = 'St Catherine', condition = function() return zones.ovda.side == 2 or zones.ovda.wasBlue end, urgent = zones.stcatherine.side == 0}),
    GroupCommander:new({name = 'AbuRudis-Support-FARP-Golf', mission = 'supply', targetzone = 'FARP-Golf', condition = function() return zones.ovda.side == 2 or zones.ovda.wasBlue end, urgent = zones.farpgolf.side == 0}),
    GroupCommander:new({name = 'AbuRudis-Support-FARP-Hotel', mission = 'supply', targetzone = 'FARP-Hotel', condition = function() return zones.ovda.side == 2 or zones.ovda.wasBlue end, urgent = zones.farphotel.side == 0}),
    GroupCommander:new({name = 'AbuRudis-Support-SAM-Delta', mission = 'supply', targetzone = 'SAM-Delta', condition = function() return zones.farpcharlie.side == 2 or zones.farpcharlie.wasBlue end}),
	GroupCommander:new({name = 'AbuRudis-Support-FARP-Juliett', mission = 'supply', targetzone = 'FARP-Juliett', condition = function() return zones.farpcharlie.side == 2 or zones.farpcharlie.wasBlue end, urgent = zones.farpjuliett.side == 0})
 
})

zones.hurghada:addGroups({
    GroupCommander:new({name = 'Hurghada-patrol-farp-foxtrot', mission = 'patrol', targetzone = 'FARP-Foxtrot', condition = function() return zones.farpcharlie.side == 2 or zones.farpcharlie.wasBlue end}),
    GroupCommander:new({name = 'Hurghada-patrol-St-Catherine', mission = 'patrol', targetzone = 'St Catherine', condition = function() return zones.farpcharlie.side == 2 or zones.farpcharlie.wasBlue end}),
    GroupCommander:new({name = 'Hurghada-Support-Farp-Foxtrot', mission = 'supply', targetzone = 'FARP-Foxtrot', condition = function() return zones.farpcharlie.side == 2 or zones.farpcharlie.wasBlue end})
})

zones.farphotel:addGroups({
	GroupCommander:new({name = 'FARP-hotel-support-sam-delta-blue', mission = 'supply', targetzone = 'SAM-Delta'})
})

zones.farpmike:addGroups({
    GroupCommander:new({name = 'Farp-Mike-Support-FARP-Juliett-Blue', mission = 'supply', targetzone = 'FARP-Juliett'}),
    GroupCommander:new({name = 'Farp-Mike-Support-FARP-India-Blue', mission = 'supply', targetzone = 'FARP-India'}),
    GroupCommander:new({name = 'Farp-Mike-Support-SAM-Echo-Blue', mission = 'supply', targetzone = 'SAM-Echo'}),
    GroupCommander:new({name = 'Farp-Mike-Support-Kibrit-Air-Base-Blue', mission = 'supply', targetzone = 'Kibrit Air Base'}),
	GroupCommander:new({name = 'Farp-Mike-Support-FARP-Juliett', mission = 'supply', targetzone = 'FARP-Juliett', condition = function() return zones.farpcharlie.side == 2 or zones.farpcharlie.wasBlue end, urgent = zones.farpjuliett.side == 0}),
    GroupCommander:new({name = 'Farp-Mike-Support-FARP-India', mission = 'supply', targetzone = 'FARP-India', condition = function() return zones.farpcharlie.side == 2 or zones.farpcharlie.wasBlue end, urgent = zones.farpindia.side == 0}),
	GroupCommander:new({name = 'Farp-Mike-Support-Wadi-al-Jandali', mission = 'supply', targetzone = 'Wadi al Jandali', condition = function() return zones.melez.side == 2 or zones.melez.wasBlue end}),
	GroupCommander:new({name = 'Farp-Mike-Support-SAM-Echo', mission = 'supply', targetzone = 'SAM-Echo', condition = function() return zones.farpcharlie.side == 2 or zones.farpcharlie.wasBlue end}),
    GroupCommander:new({name = 'Farp-Mike-Attack-FARP-Juliett', mission = 'attack', targetzone = 'FARP-Juliett', condition = function() return zones.farpcharlie.side == 2 or zones.farpcharlie.wasBlue end}),
    GroupCommander:new({name = 'Farp-Mike-Attack-FARP-India', mission = 'attack', targetzone = 'FARP-India', condition = function() return zones.farpcharlie.side == 2 or zones.farpcharlie.wasBlue end}),
	GroupCommander:new({name = 'Farp-Mike-Support-Kibrit-Air-Base', mission = 'supply', targetzone = 'Kibrit Air Base'})
})


zones.farpjuliett:addGroups({
    GroupCommander:new({name = 'FARP-Juliett-Supply-FARP-Mike-blue', mission = 'supply', targetzone = 'FARP-Mike'})
})

zones.farpfoxtrot:addGroups({
    GroupCommander:new({name = 'Farp-Foxtrot-Supply-Hurhgada', mission = 'supply', targetzone = 'Hurghada International Airport', condition = function() return zones.stcatherine.side == 2 or zones.stcatherine.wasBlue end})
})

zones.elarish:addGroups({
    GroupCommander:new({name = 'El-Arish-Patrol-Melez-blue', mission = 'patrol', targetzone = 'Melez'}),
    GroupCommander:new({name = 'El-Arish-support-Farp-Lima-blue', mission = 'supply', targetzone = 'FARP-Lima'}),
    GroupCommander:new({name = 'El-Arish-Supply-El-Gorah', mission = 'supply', targetzone = 'El Gora'})
})

zones.almansurah:addGroups({
    GroupCommander:new({name = 'Al Mansurah-Support-Al Salihiyah', mission = 'supply', targetzone = 'Al Salihiyah'}),
    GroupCommander:new({name = 'Al Mansurah-Support-SAM-Juliett', mission = 'supply', targetzone = 'SAM-Juliett'}),
    GroupCommander:new({name = 'Al Mansurah-Support-AzZaqaziq', mission = 'supply', targetzone = 'AzZaqaziq'}),
    GroupCommander:new({name = 'Al Mansurah-Support-SAM-Juliett-blue', mission = 'supply', targetzone = 'SAM-Juliett'}),
    GroupCommander:new({name = 'Al Mansurah-Support-Birma-Air-Base', mission = 'supply', targetzone = 'Birma Air Base'}),
    GroupCommander:new({name = 'Al Mansurah-Support-Birma-Air-Base-Blue', mission = 'supply', targetzone = 'Birma Air Base'})
})

zones.azzaqaziq:addGroups({
    GroupCommander:new({name = 'AzZaqaziq-Patrol-Red Carrier', mission = 'patrol', targetzone = 'Red Carrier'}),
    GroupCommander:new({name = 'AzZaqaziq-Support-As Salihiyah', mission = 'supply', targetzone = 'As Salihiyah'}),
    GroupCommander:new({name = 'AzZaqaziq-Support-Abu Suwayr', mission = 'supply', targetzone = 'Abu Suwayr'}),
    GroupCommander:new({name = 'AzZaqaziq-Support-Al Ismailiyah', mission = 'supply', targetzone = 'Al Ismailiyah'}),
    GroupCommander:new({name = 'AzZaqaziq-Support-Difarsuwar', mission = 'supply', targetzone = 'Difarsuwar Airfield'}),
    GroupCommander:new({name = 'AzZaqaziq-Support-Fayed', mission = 'supply', targetzone = 'Fayed'}),
    GroupCommander:new({name = 'AzZaqaziq-Support-Kibrit', mission = 'supply', targetzone = 'Kibrit Air Base'}),
    GroupCommander:new({name = 'AzZaqaziq-Attack-As Salihiyah', mission = 'attack', targetzone = 'As Salihiyah'}),
    GroupCommander:new({name = 'AzZaqaziq-Attack-Abu Suwayr', mission = 'attack', targetzone = 'Abu Suwayr'}),
    GroupCommander:new({name = 'AzZaqaziq-Attack-Fayed', mission = 'attack', targetzone = 'Fayed'}),
    GroupCommander:new({name = 'azzaqaziq-Supply-Al-Mansurah-Blue', mission = 'supply', targetzone = 'Al Mansurah'}),
	GroupCommander:new({name = 'AzZaqaziq-Supply-Al-Mansurah', mission = 'supply', targetzone = 'Al Mansurah', urgent = zones.almansurah.side == 0}),
    GroupCommander:new({name = 'AzZaqaziq-Supply-Quwaysina-Blue', mission = 'supply', targetzone = 'Quwaysina'}),
    GroupCommander:new({name = 'AzZaqaziq-Supply-Bilbeis-air-base-blue', mission = 'supply', targetzone = 'Bilbeis Air Base'}),
    GroupCommander:new({name = 'AzZaqaziq-Supply-Bilbeis-air-base', mission = 'supply', targetzone = 'Bilbeis Air Base', urgent = zones.bilbeisairbase.side == 0}),
    GroupCommander:new({name = 'AzZaqaziq-Supply-Quwaysina', mission = 'supply', targetzone = 'Quwaysina', urgent = zones.quwaysina.side == 0})
})


zones.wadialjandali:addGroups({
    GroupCommander:new({name = 'Wadi-Support-Beni-Suef-Blue', mission = 'supply', targetzone = 'Beni Suef'}),
	GroupCommander:new({name = 'Wadi-Support-Bilbeis-Kom-Awshim-Blue', mission = 'supply', targetzone = 'Kom Awshim'}),
	GroupCommander:new({name = 'Wadi-Support-Bilbeis-Air-Base-blue', mission = 'supply', targetzone = 'Bilbeis Air Base'}),
	GroupCommander:new({name = 'Wadi-Support-Cairo-International-Airport-blue', mission = 'supply', targetzone = 'Cairo International Airport'}),
    GroupCommander:new({name = 'Wadi-Attack-Ramon', mission = 'patrol', targetzone = 'Melez', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.side == 2 end}),
    GroupCommander:new({name = 'Wadi-Attack-Catherine', mission = 'patrol', targetzone = 'Abu Rudeis'}),
    GroupCommander:new({name = 'Wadi-Attack-FARP-Mike', mission = 'attack', targetzone = 'FARP-Mike'}),
    GroupCommander:new({name = 'Wadi-Support-FARP-Mike', mission = 'supply', targetzone = 'FARP-Mike', type = 'surface', condition = function() return zones.melez.side == 2 or zones.stcatherine.side == 2 end}),
    GroupCommander:new({name = 'Wadi-Attack-Baluza', mission = 'attack', targetzone = 'Baluza'}),
    GroupCommander:new({name = 'Wadi-al-jandali-support-Sam-Lima-blue', mission = 'supply', targetzone = 'SAM-Lima', type = 'surface'}),
    GroupCommander:new({name = 'Wadi-al-jandali-support-Sam-Lima-red', mission = 'supply', targetzone = 'SAM-Lima', type = 'surface', condition = function() return zones.melez.side == 2 or zones.melez.wasBlue end}),  
    GroupCommander:new({name = 'Wadi-Attack-Melez-and-kibrit', mission = 'attack', targetzone = 'Melez'}),
	GroupCommander:new({name = 'Wadi-Support-Kom-Awshim', mission = 'supply', targetzone = 'Kom Awshim', condition = function() return zones.melez.side == 2 or zones.melez.wasBlue end, urgent = zones.komawshim.side == 0}),
	GroupCommander:new({name = 'Wadi-Support-cairo-international-airport', mission = 'supply', targetzone = 'Cairo International Airport', condition = function() return zones.melez.side == 2 or zones.melez.wasBlue end, urgent = zones.cairointernationalairport.side == 0})
	
	
})

zones.fayed:addGroups({
    GroupCommander:new({name = 'Fayed-Support-Difarsuwar-Airfield-blue', mission = 'supply', targetzone = 'Difarsuwar Airfield'}),
    GroupCommander:new({name = 'Fayed-Support-abu-Suwayr-blue', mission = 'supply', targetzone = 'Abu Suwayr'}),
	GroupCommander:new({name = 'Fayed-Patrol-Melez', mission = 'patrol', targetzone = 'Melez', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end}),
	GroupCommander:new({name = 'Fayed-Support-abu-Suwayr', mission = 'supply', targetzone = 'Abu Suwayr', condition = function() return zones.melez.side == 2 or zones.melez.wasBlue end}),
    GroupCommander:new({name = 'Fayed-Supply-difarsuwar-airfiled', mission = 'supply', targetzone = 'Difarsuwar Airfield', type = 'surface', condition = function() return zones.melez.side == 2 or zones.melez.wasBlue end}),
	GroupCommander:new({name = 'Fayed-Support-Wadi-Al-Jandali', mission = 'supply', targetzone = 'Wadi al Jandali', condition = function() return zones.melez.side == 2 or zones.melez.wasBlue end})
})

zones.alismailiyah:addGroups({
    GroupCommander:new({name = 'ismailiyah-Patrol-Melez', mission = 'patrol', targetzone = 'Melez', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end}),
    GroupCommander:new({name = 'ismailiyah-support-difarsuwar', mission = 'supply', targetzone = 'Difarsuwar Airfield'}),
	GroupCommander:new({name = 'ismailiyah-support-assalihiyah', mission = 'supply', targetzone = 'As Salihiyah', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end})
	
})

zones.bilbeisairbase:addGroups({
    GroupCommander:new({name = 'bilbeis-air-base-Supply-insha-air-base-blue', mission = 'supply', targetzone = 'Inshas Airbase'}),
    GroupCommander:new({name = 'bilbeis-air-base-Supply-insha-air-base', mission = 'supply', targetzone = 'Inshas Airbase'})
})

zones.abusuwayr:addGroups({
    GroupCommander:new({name = 'Abu-Suwayr-attack-Melez', mission = 'attack', targetzone = 'Melez'}),
    GroupCommander:new({name = 'Abu-Suway-Support-Azzaqaziq-blue', mission = 'supply', targetzone = 'AzZaqaziq'}),
    GroupCommander:new({name = 'Abu-Suwayr-Attack-Al-Salihiyah', mission = 'attack', targetzone = 'As Salihiyah', type = 'surface'})
})

zones.assalihiyah:addGroups({
	GroupCommander:new({name = 'AzZaqaziq-Patrol-Red Carrier', mission = 'patrol', targetzone = 'Red Carrier'}),
    GroupCommander:new({name = 'As-Salihiyah-Support-Sam-India-red', mission = 'supply', targetzone = 'SAM-India', type = 'surface'}),
    GroupCommander:new({name = 'As-Salihiyah-Supply-Baluza', mission = 'supply', targetzone = 'Baluza', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end}),
	GroupCommander:new({name = 'As-Salihiyah-supply-al-ismailiyah', mission = 'supply', targetzone = 'Al Ismailiyah', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end}),
    GroupCommander:new({name = 'As-Salihiyah-Support-Sam-India-blue', mission = 'supply', targetzone = 'SAM-India', type = 'surface'}),
    GroupCommander:new({name = 'As-Salihiyah-Patrol-Melez', mission = 'patrol', targetzone = 'Melez', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end}),
    GroupCommander:new({name = 'As-Salihiyah-attack-Melez', mission = 'attack', targetzone = 'Melez'}),
	GroupCommander:new({name = 'As-Salihiyah-Supply-AzZaqaziq', mission = 'supply', targetzone = 'AzZaqaziq', condition = function() return zones.melez.side == 2 or zones.melez.wasBlue end, urgent = zones.azzaqaziq.side == 0}),
	GroupCommander:new({name = 'As-Salihiyah-Supply-almansurah', mission = 'supply', targetzone = 'Al Mansurah', condition = function() return zones.melez.side == 2 or zones.melez.wasBlue end, urgent = zones.almansurah.side == 0})

})

zones.kibritairbase:addGroups({
    GroupCommander:new({name = 'Kibrit-Air-Base-Support-Fayed-Blue', mission = 'supply', targetzone = 'Fayed'}),
    GroupCommander:new({name = 'Kibrit Air Base-supply-Farp-Mike', mission = 'supply', targetzone = 'FARP-Mike'}),
    GroupCommander:new({name = 'Kibrit-Air-Base-support-Melez', mission = 'supply', targetzone = 'Melez', condition = function() return zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue end}),
    GroupCommander:new({name = 'Kibrit-Air-Base-support-fayed', mission = 'supply', targetzone = 'Fayed', condition = function() return zones.melez.side == 2 or zones.melez.wasBlue end}),
    GroupCommander:new({name = 'Kibrit-Air-Base-patrol-Patrol-Abu-Rudeis', mission = 'patrol', targetzone = 'Abu Rudeis'}),
	GroupCommander:new({name = 'Kibrit-Air-Base-support-sam-foxtrot', mission = 'supply', targetzone = 'SAM-Foxtrot'})
})

zones.inshasairbase:addGroups({
    GroupCommander:new({name = 'Inshas-Airbase-patrol-al-ismailiyah', mission = 'patrol', targetzone = 'Al Ismailiyah'}),
    GroupCommander:new({name = 'Inshas-Airbase-patrol-SAM-Juliett', mission = 'patrol', targetzone = 'SAM-Juliett'}),
    GroupCommander:new({name = 'Inshas-AirBase-Support-Cairo-International', mission = 'supply', targetzone = 'Cairo International Airport'}),
    GroupCommander:new({name = 'Inshas-AirBase-Support-Cairo-West-Blue', mission = 'supply', targetzone = 'Cairo West'}),
    GroupCommander:new({name = 'Inshas-AirBase-Support-Cairo-West', mission = 'supply', targetzone = 'Cairo West'})
})

zones.komawshim:addGroups({
    GroupCommander:new({name = 'Kom-Awshim-Support-Beni-Suef', mission = 'supply', targetzone = 'Beni Suef'}),
    GroupCommander:new({name = 'Kom-Awshim-Support-Cairo West', mission = 'supply', targetzone = 'Cairo West'}),
    GroupCommander:new({name = 'Kom-Awshim-Support-Beni-Suef-Blue', mission = 'supply', targetzone = 'Beni Suef'})
})

zones.birmaairbase:addGroups({
    GroupCommander:new({name = 'Birma-Air-Base-attack-Abu-swayr', mission = 'attack', targetzone = 'Abu Suwayr'})
})

zones.quwaysina:addGroups({
    GroupCommander:new({name = 'Quwaysina-support-Birma-Air-Base', mission = 'attack', targetzone = 'Birma Air Base'}),
    GroupCommander:new({name = 'Quwaysina-support-Birma-Air-Base-blue', mission = 'attack', targetzone = 'Birma Air Base'})
})

zones.cairowest:addGroups({
    
    GroupCommander:new({name = 'CairoWest-Support-Melez', mission = 'supply', targetzone = 'Melez'}),
    GroupCommander:new({name = 'CairoWest-Support-SAM-Mike', mission = 'supply', targetzone = 'SAM-Mike'}),
    GroupCommander:new({name = 'CairoWest-Patrol-Wadi', mission = 'patrol', targetzone = 'Wadi al Jandali'}),
    GroupCommander:new({name = 'CairoWest-Patrol-AzZaqaziq', mission = 'patrol', targetzone = 'AzZaqaziq'}),
    GroupCommander:new({name = 'CairoWest-Support-Wadi', mission = 'supply', targetzone = 'Wadi al Jandali'}),
    GroupCommander:new({name = 'CairoWest-Patrol-Cario-West', mission = 'patrol', targetzone = 'Cairo West'})
})
function SpawnFriendlyAssets()

    if  (zones.melez.side == 2 or zones.melez.wasBlue) and
        (zones.samgolf.side == 2 or zones.samgolf.wasBlue) then
        

        local blueAwacsGroup = Group.getByName('Blue AWACS-Melez')
        if not Utils.isGroupActive(blueAwacsGroup) then
            mist.respawnGroup('Blue AWACS-Melez', true)
        end


        local airforceTankerGroup = Group.getByName('airforce-tanker-Melez')
        if not Utils.isGroupActive(airforceTankerGroup) then
            mist.respawnGroup('airforce-tanker-Melez', true)
        end


        local navyTankerGroup = Group.getByName('navy-tanker-Melez')
        if not Utils.isGroupActive(navyTankerGroup) then
            mist.respawnGroup('navy-tanker-Melez', true)
        end


        local navyTankerMelez5Group = Group.getByName('navy-tanker-Melez5')
        if not Utils.isGroupActive(navyTankerMelez5Group) then
            mist.respawnGroup('navy-tanker-Melez5', true)
        end
    end
    
    if  (zones.ramonairbase.side == 2 and zones.melez.side == 1) then
                

        local airforceTankerGroup = Group.getByName('airforce-tanker')
        if not Utils.isGroupActive(airforceTankerGroup) then
            mist.respawnGroup('airforce-tanker', true)
        end


        local navyTankerGroup = Group.getByName('navy-tanker')
        if not Utils.isGroupActive(navyTankerGroup) then
            mist.respawnGroup('navy-tanker', true)
        end
    end
end

	
mist.scheduleFunction(SpawnFriendlyAssets, {}, timer.getTime() + 30)


function checkAndDisableFriendlyZones()
    if (zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue) then
        zones.hatzor:disableFriendlyZone()
        zones.sdedov:disableFriendlyZone()
        zones.bengurion:disableFriendlyZone()
        zones.palmahim:disableFriendlyZone()
        zones.telnof:disableFriendlyZone()
        zones.kedemhatzerim:disableFriendlyZone()
        zones.nevatim:disableFriendlyZone()
        zones.samalpha:disableFriendlyZone()
    end

		if zones.farpdelta.side == 2 or zones.farpdelta.wasBlue then
         zones.farpbravo:disableFriendlyZone()
    end
	
	if  zones.sharmelsheikh.side == 2 or zones.sharmelsheikh.wasBlue then
        zones.farpdelta:disableFriendlyZone()
    end
	
    if (zones.ovda.side == 2 or zones.ovda.wasBlue) and (zones.farpkilo.side == 2 or zones.farpkilo.wasBlue) then
        zones.farpalpha:disableFriendlyZone()
    end

    if  (zones.melez.side == 2 or zones.melez.wasBlue) and 
		(zones.ramonairbase.side == 2 or zones.ramonairbase.wasBlue) and
		(zones.elarish.side == 2 or zones.elarish.wasBlue) then
        zones.ramonairbase:disableFriendlyZone()
        zones.sambravo:disableFriendlyZone()
        zones.farpkilo:disableFriendlyZone()
        zones.elgora:disableFriendlyZone()
        zones.elarish:disableFriendlyZone()
		zones.ovda:disableFriendlyZone()
		zones.stcatherine:disableFriendlyZone()
    end

	if  (zones.stcatherine.side == 2 or zones.stcatherine.wasBlue) and 
		(zones.farpdelta.side == 2 or zones.farpdelta.wasBlue) then
        zones.farpcharlie:disableFriendlyZone()
    end

	 if (zones.farpfoxtrot.side == 2 or zones.farpfoxtrot.wasBlue) and 
		(zones.sharmelsheikh.side == 2 or zones.sharmelsheikh.wasBlue) and 
		(zones.hurghada.side == 2 or zones.hurghada.wasBlue) then
        zones.farpdelta:disableFriendlyZone()
        zones.farpecho:disableFriendlyZone()
        zones.farpfoxtrot:disableFriendlyZone()
        zones.farpcharlie:disableFriendlyZone()
    end

     if (zones.wadialjandali.side == 2 or zones.wadialjandali.wasBlue) and 
		(zones.alismailiyah.side == 2 or zones.alismailiyah.wasBlue) and 
		(zones.farpmike.side == 2 or zones.farpmike.wasBlue) then
        zones.melez:disableFriendlyZone()
        zones.farplima:disableFriendlyZone()
        zones.birhasanah:disableFriendlyZone()
        zones.farpindia:disableFriendlyZone()
        zones.farpgolf:disableFriendlyZone()
        zones.farpjuliett:disableFriendlyZone()
        zones.stcatherine:disableFriendlyZone()
		zones.samcharlie:disableFriendlyZone()
    end
	
	 if (zones.farpmike.side == 2 or zones.farpmike.wasBlue) and
		(zones.farpjuliett.side == 2 or zones.farpjuliett.wasBlue) then
        zones.farpindia:disableFriendlyZone()
        zones.farpjuliett:disableFriendlyZone()
        zones.farphotel:disableFriendlyZone()
		zones.aburudeis:disableFriendlyZone()
		zones.stcatherine:disableFriendlyZone()
	end
	
	if (zones.hurghada.side == 2 or zones.hurghada.wasBlue) and 
		(zones.aburudeis.side == 2 or zones.aburudeis.wasBlue) and 
		(zones.farphotel.side == 2 or zones.farphotel.wasBlue) then
        zones.hurghada:disableFriendlyZone()
        zones.sharmelsheikh:disableFriendlyZone()
        zones.farpecho:disableFriendlyZone()
        zones.farpgolf:disableFriendlyZone()
        zones.farpfoxtrot:disableFriendlyZone()
    end
    
    -- Debugging statement
    --trigger.action.outText("checkAndDisableFriendlyZones called", 10)
end

-- Schedule the function to run 5 seconds after mission start, then every 30 minutes (1800 seconds)
mist.scheduleFunction(checkAndDisableFriendlyZones, {}, timer.getTime() + 5)


for i,v in pairs(zones) do
	bc:addZone(v)
end

bc:addConnection("Blue Carrier","Sde Dov")
bc:addConnection("Sde Dov","Ben-Gurion")
bc:addConnection("Ben-Gurion","Palmahim")
bc:addConnection("Palmahim","Tel Nof")
bc:addConnection("Tel Nof","Hatzor")
bc:addConnection("Hatzor","Kedem-Hatzerim")
bc:addConnection("Kedem-Hatzerim","Nevatim")
bc:addConnection("Kedem-Hatzerim","Ramon Airbase")
bc:addConnection("Kedem-Hatzerim","El Gora")
bc:addConnection("El Gora","El Arish")
bc:addConnection("El Arish","FARP-Lima")
bc:addConnection("Ramon Airbase","FARP-Alpha")
bc:addConnection("Ramon Airbase","Nevatim")
bc:addConnection("Ramon Airbase","El Gora")
bc:addConnection("FARP-Alpha","Ovda")
bc:addConnection("Ovda","FARP-Bravo")
bc:addConnection("FARP-Bravo","FARP-Charlie")
bc:addConnection("FARP-Charlie","FARP-Delta")
bc:addConnection("FARP-Charlie","St Catherine")
bc:addConnection("St Catherine","FARP-Delta")
bc:addConnection("St Catherine","FARP-Echo")
bc:addConnection("St Catherine","Sharm El Sheikh International Airport")
bc:addConnection("Sharm El Sheikh International Airport","Hurghada International Airport")
bc:addConnection("Hurghada International Airport","FARP-Echo")
bc:addConnection("Hurghada International Airport","FARP-Foxtrot")
bc:addConnection("St Catherine","FARP-Golf")
bc:addConnection("St Catherine","Abu Rudeis")
bc:addConnection("FARP-Echo","FARP-Foxtrot")
bc:addConnection("FARP-Golf","FARP-Foxtrot")
bc:addConnection("FARP-Golf","FARP-Hotel")
bc:addConnection("FARP-Hotel","Abu Rudeis")
bc:addConnection("Abu Rudeis","FARP-India")
bc:addConnection("FARP-India","FARP-Juliett")
bc:addConnection("FARP-Juliett","FARP-Mike")
bc:addConnection("FARP-Mike","Kibrit Air Base")
bc:addConnection("FARP-Mike","Wadi al Jandali")
bc:addConnection("FARP-Alpha","FARP-Kilo")
bc:addConnection("FARP-Kilo","Bir Hasanah")
bc:addConnection("Bir Hasanah","Melez")
bc:addConnection("Melez","FARP-Lima")
bc:addConnection("FARP-Lima","Baluza")
bc:addConnection("Baluza","As Salihiyah")
bc:addConnection("As Salihiyah","Al Ismailiyah")
bc:addConnection("As Salihiyah","Abu Suwayr")
bc:addConnection("As Salihiyah","AzZaqaziq")
bc:addConnection("As Salihiyah","Al Mansurah")
bc:addConnection("Abu Suwayr", "Difarsuwar Airfield")
bc:addConnection("Al Ismailiyah", "Difarsuwar Airfield")
bc:addConnection("Difarsuwar Airfield", "Fayed")
bc:addConnection("Fayed", "Kibrit Air Base")
bc:addConnection("Kibrit Air Base", "Melez")
bc:addConnection("Fayed", "Wadi al Jandali")
bc:addConnection("Al Mansurah", "AzZaqaziq")
bc:addConnection("Quwaysina", "AzZaqaziq")
bc:addConnection("AzZaqaziq", "Bilbeis Air Base")
bc:addConnection("Bilbeis Air Base", "Inshas Airbase")
bc:addConnection("Inshas Airbase", "Cairo International Airport")
bc:addConnection("Cairo International Airport", "Wadi al Jandali")
bc:addConnection("Cairo West", "Quwaysina")
bc:addConnection("Cairo West", "Quwaysina")
bc:addConnection("Birma Air Base", "Quwaysina")
bc:addConnection("Cairo West", "Cairo International Airport")
bc:addConnection("Cairo West", "Kom Awshim")
bc:addConnection("Beni Suef", "Wadi al Jandali")
bc:addConnection("Beni Suef", "Kom Awshim")

bc:addConnection("Hatzor","SAM-Alpha")
bc:addConnection("Ramon Airbase","SAM-Bravo")
bc:addConnection("St Catherine","SAM-Charlie")
bc:addConnection("FARP-Golf","SAM-Delta")
bc:addConnection("FARP-Juliett","SAM-Echo")
bc:addConnection("Bir Hasanah","SAM-Foxtrot")
bc:addConnection("Melez","SAM-Golf")
bc:addConnection("Baluza","SAM-Hotel")
bc:addConnection("As Salihiyah","SAM-India")
bc:addConnection("Al Mansurah","SAM-Juliett")
bc:addConnection("Birma Air Base","SAM-Juliett")
bc:addConnection("Beni Suef","SAM-Kilo")
bc:addConnection("Wadi al Jandali","SAM-Lima")
bc:addConnection("Cairo West","SAM-Mike")



zones.tankfactory:addCriticalObject('TankFactory1')
zones.tankfactory:addCriticalObject('TankFactory2')
zones.tankfactory:addCriticalObject('TankFactory3')
zones.tankfactory:addCriticalObject('TankFactory4')

zones.fueldepo:addCriticalObject('Fueldepo1')
zones.fueldepo:addCriticalObject('Fueldepo2')
zones.fueldepo:addCriticalObject('Fueldepo3')
zones.fueldepo:addCriticalObject('Fueldepo4')
zones.fueldepo:addCriticalObject('Fueldepo5')
zones.fueldepo:addCriticalObject('Fueldepo6')


zones.chemsite:addCriticalObject('chemsite1')
zones.chemsite:addCriticalObject('chemsite2')
zones.chemsite:addCriticalObject('chemsite3')
zones.chemsite:addCriticalObject('chemsite4')
zones.chemsite:addCriticalObject('chemsite5')
zones.chemsite:addCriticalObject('chemsite6')
zones.chemsite:addCriticalObject('chemsite7')
zones.chemsite:addCriticalObject('chemsite8')

zones.missilefactory:addCriticalObject('missilefactory1')
zones.missilefactory:addCriticalObject('missilefactory2')

zones.secrettechfacility:addCriticalObject('SecretTechFacility1')
zones.secrettechfacility:addCriticalObject('SecretTechFacility2')
zones.secrettechfacility:addCriticalObject('SecretTechFacility3')
zones.secrettechfacility:addCriticalObject('SecretTechFacility4')
zones.secrettechfacility:addCriticalObject('SecretTechFacility5')


zones.ammonitiondepo:addCriticalObject('Ammodepo1')
zones.ammonitiondepo:addCriticalObject('Ammodepo2')
zones.ammonitiondepo:addCriticalObject('Ammodepo3')
zones.ammonitiondepo:addCriticalObject('Ammodepo4')


zones.tankfactory:registerTrigger('destroyed', function(event, sender) 
	sender:disableZone()
	bc:addFunds(2,500)
	trigger.action.outTextForCoalition(2,'Tank Factroy cleared\n+500 credits',20)
end, 'disabletankfactory1')

zones.tankfactory:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
end, 'disabletankfactory2')

zones.fueldepo:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
end, 'disablefueldepo1')

zones.fueldepo:registerTrigger('destroyed', function(event, sender) 
	bc:addFunds(2,500)
	trigger.action.outTextForCoalition(2,'Fuel Depo disabled, Great job!\n+500 credits',20)
end, 'disablefueldepo2')

zones.secrettechfacility:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
end, 'disablesecrettechfacility1')

zones.secrettechfacility:registerTrigger('destroyed', function(event, sender) 
	bc:addFunds(2,500)
	trigger.action.outTextForCoalition(2,'secret tech facility disabled\n+500 credits',20)
end, 'disablesecrettechfacility2')



zones.miningfacility:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
	bc:addFunds(2,500)
	trigger.action.outTextForCoalition(2,'Mining Facility cleared\n+500 credits',20)
end, 'disableminingfacility')


zones.ammonitiondepo:registerTrigger('destroyed', function(event, sender) 
	sender:disableZone()
	bc:addFunds(2,500)
	trigger.action.outTextForCoalition(2,'Ammunition Depo cleared\n+500 credits',20)
end, 'disableammonitiondepo1')

zones.ammonitiondepo:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
end, 'disableammonitiondepo2')

zones.insurgentcamp:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
	bc:addFunds(2,500)
	trigger.action.outTextForCoalition(2,'Insurgent Camp destroyed, Good job\n+500 credits',20)
end, 'disableinsurgentcamp')


zones.chemsite:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
end, 'disablechemsite1')


zones.chemsite:registerTrigger('destroyed', function(event, sender) 
	sender:disableZone()
	bc:addFunds(2,500)
	trigger.action.outTextForCoalition(2,'chemical site destroyed, Good job\n+500 credits',20)
end, 'disablechemsite2')


zones.missilefactory:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
	bc:addFunds(2,500)
	trigger.action.outTextForCoalition(2,'Missile Factroy destroyed, Good job\n+500 credits',20)
end, 'disablemissilefactory')





local missionCompleted = false

local checkMissionComplete = function(event, sender)
    local done = true
    for i, v in ipairs(bc:getZones()) do
        if v.side == 1 then
            done = false
            break
        end
    end

    if done then
        missionCompleted = true  -- Set the flag when mission is complete
        trigger.action.outText("Enemy has been defeated. \n\nMission Complete.", 120)
        
        -- Schedule the audio to play after a 5-second delay
        timer.scheduleFunction(function()
            trigger.action.outSoundForCoalition(2, "BH.ogg")
        end, {}, timer.getTime() + 5)
    end
end


local upgradeMenu = nil
bc:registerShopItem('supplies', 'Resupply or upgrade friendly Zone', 149, function(sender)
	if upgradeMenu then
		return 'Choose zone from F10 menu'
	end
	
	local upgradeZone = function(target)
		if upgradeMenu then
			local zn = bc:getZoneByName(target)
			if zn and zn.side==2 then
				zn:upgrade()
			else
				return 'Zone not friendly'
			end
			
			upgradeMenu = nil
		end
	end
	
	upgradeMenu = bc:showTargetZoneMenu(2, 'Select Zone to resupply or upgrade', upgradeZone, 2)
	
	trigger.action.outTextForCoalition(2, 'Supplies prepared. Choose zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		params.zone:upgrade()
	else
		return 'Can only target friendly zone'
	end
end)

Group.getByName('f16cap1'):destroy()
Group.getByName('f16cap2'):destroy()
Group.getByName('f16cap3'):destroy()
Group.getByName('f16cap4'):destroy()
Group.getByName('f16cap5'):destroy()

bc:registerShopItem('cap', 'CAP ', 300, 
    function(sender)
        local grname = 'f16cap1'
        if (zones.ramonairbase.side == 2 and zones.kedemhatzerim.side == 2 and zones.ovda.side == 1) then
        grname = 'f16cap2'
    elseif (zones.birhasanah.side == 1 and zones.ovda.side == 2 and zones.stcatherine.side == 2) then
        grname = 'f16cap3'
	elseif (zones.birhasanah.side == 2 and zones.samgolf.side == 2 and zones.azzaqaziq.side == 1) then
        grname = 'f16cap4'
	elseif (zones.azzaqaziq.side == 2 and zones.samindia.side == 2 and zones.abusuwayr.side == 2) then
        grname = 'f16cap5'
    
    end

        local gr = Group.getByName(grname)
        if Utils.isGroupActive(gr) then
            return 'CAP mission still in progress'
        end

        mist.respawnGroup(grname, true)
    end, 
    function(sender, params)
        local grname = 'f16cap1'
        if (zones.ramonairbase.side == 2 and zones.kedemhatzerim.side == 2 and zones.ovda.side == 1) then
        grname = 'f16cap2'
    elseif (zones.birhasanah.side == 1 and zones.ovda.side == 2 and zones.stcatherine.side == 2) then
        grname = 'f16cap3'
	elseif (zones.birhasanah.side == 2 and zones.samgolf.side == 2 and zones.azzaqaziq.side == 1) then
        grname = 'f16cap4'
	elseif (zones.azzaqaziq.side == 2 and zones.samindia.side == 2 and zones.abusuwayr.side == 2) then
        grname = 'f16cap5'
    end

        local gr = Group.getByName(grname)
        if Utils.isGroupActive(gr) then
            return 'CAP mission still in progress'
        end

        mist.respawnGroup(grname, true)
    end
) -- close the registerShopItem function

tanksMenu = nil
bc:registerShopItem('armor', 'Deploy armor (for combined arms) ', 300, function(sender)
	
	if tanksMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployTanks = function(target)
		if tanksMenu then
		
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-tanks')
			
			tanksMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly armor deployed at '..target, 15)
		end
	end
	
	tanksMenu = bc:showTargetZoneMenu(2, 'Deploy armor (Choose friendly zone) ', deployTanks, 2)
	trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-tanks')
		trigger.action.outTextForCoalition(2, 'Friendly armor deployed at '..params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)

artyMenu = nil
bc:registerShopItem('artillery', 'Deploy artillery (for combined arms) ', 200, function(sender)
	
	if artyMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployArty = function(target)
		if artyMenu then
		
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-arty')
			
			artyMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly artillery deployed at '..target, 15)
		end
	end
	
	artyMenu = bc:showTargetZoneMenu(2, 'Deploy artillery (Choose friendly zone) ', deployArty, 2)
	trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu ', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-arty')
		trigger.action.outTextForCoalition(2, 'Friendly artillery deployed at '..params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)

reconMenu = nil
bc:registerShopItem('recon', 'Deploy recon group (for combined arms)', 50, function(sender)
	
	if reconMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployRecon = function(target)
		if reconMenu then
		
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-recon')
			
			reconMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly recon group deployed at '..target, 15)
		end
	end
	
	reconMenu = bc:showTargetZoneMenu(2, 'Deploy recon group (Choose friendly zone)', deployRecon, 2)
	trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-recon')
		trigger.action.outTextForCoalition(2, 'Friendly recon group deployed at '..params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)

airdefMenu = nil
bc:registerShopItem('airdef', 'Deploy air defence (for combined arms)', 150, function(sender)
	
	if airdefMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployAirDef = function(target)
		if airdefMenu then
		
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-airdef')
			
			airdefMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly air defence deployed at '..target, 15)
		end
	end
	
	airdefMenu = bc:showTargetZoneMenu(2, 'Deploy air defence (Choose friendly zone)', deployAirDef, 2)
	trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-airdef')
		trigger.action.outTextForCoalition(2, 'Friendly air defence deployed at '..params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)


Group.getByName('jtacDrone'):destroy()
local jtacTargetMenu = nil
drone = JTAC:new({name = 'jtacDrone'})
bc:registerShopItem('jtac', 'MQ-9 Reaper JTAC mission ', 300, function(sender)
	
	if jtacTargetMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local spawnAndOrbit = function(target)
		if jtacTargetMenu then
			local zn = bc:getZoneByName(target)
			drone:deployAtZone(zn)
			drone:showMenu()
			trigger.action.outTextForCoalition(2, 'Reaper drone deployed over '..target, 15)
			jtacTargetMenu = nil
		end
	end
	
	jtacTargetMenu = bc:showTargetZoneMenu(2, 'Deploy JTAC ', spawnAndOrbit, 1)
	
	trigger.action.outTextForCoalition(2, 'Choose which zone to deploy JTAC at from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 1 then
		drone:deployAtZone(params.zone)
		drone:showMenu()
		trigger.action.outTextForCoalition(2, 'Reaper drone deployed over '..params.zone.zone, 15)
	else
		return 'Can only target enemy zone'
	end
end)

local smoketargets = function(tz)
	local units = {}
	for i,v in pairs(tz.built) do
		local g = Group.getByName(v)
		for i2,v2 in ipairs(g:getUnits()) do
			table.insert(units, v2)
		end
	end
	
	local tgts = {}
	for i=1,3,1 do
		if #units > 0 then
			local selected = math.random(1,#units)
			table.insert(tgts, units[selected])
			table.remove(units, selected)
		end
	end
	
	for i,v in ipairs(tgts) do
		local pos = v:getPosition().p
		trigger.action.smoke(pos, 1)
	end
end

local smokeTargetMenu = nil
bc:registerShopItem('smoke', 'Smoke markers ', 20, function(sender)
	if smokeTargetMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local launchAttack = function(target)
		if smokeTargetMenu then
			local tz = bc:getZoneByName(target)
			smoketargets(tz)
			smokeTargetMenu = nil
			trigger.action.outTextForCoalition(2, 'Targets marked with RED smoke at '..target, 15)
		end
	end
	
	smokeTargetMenu = bc:showTargetZoneMenu(2, 'Smoke marker target', launchAttack, 1)
	
	trigger.action.outTextForCoalition(2, 'Choose target zone from F10 menu ', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 1 then
		smoketargets(params.zone)
		trigger.action.outTextForCoalition(2, 'Targets marked with RED smoke at '..params.zone.zone, 15)
	else
		return 'Can only target enemy zone'
	end
end)

------------------------------------ START own 9 line jtac AM START ----------------------------------
Group.getByName('JTAC9lineam'):destroy()
local jtacTargetMenu2 = nil
local droneAM = JTAC9line:new({name = 'JTAC9lineam'})  -- Renamed to droneAM for clarity
bc:registerShopItem('9lineam', '9 line Jtac AM ', 0, function(sender)
    if jtacTargetMenu2 then
        return 'Choose target zone from F10 menu'
    end
    
    local spawnAndOrbit2 = function(target)
        if jtacTargetMenu2 then
            local zn = bc:getZoneByName(target)
            droneAM:deployAtZone(zn)
		trigger.action.outTextForCoalition(2, 'Reaper drone deployed over ' .. target .. '. Contact Springfield on 241.00 AM ', 30)
        jtacTargetMenu2 = nil
		end
    end
    
    jtacTargetMenu2 = bc:showTargetZoneMenu(2, 'Deploy JTAC to Zone', spawnAndOrbit2, 1)
    trigger.action.outTextForCoalition(2, 'Choose which zone to deploy JTAC at from F10 menu', 15)
end,
function(sender, params)
    if params.zone and params.zone.side == 1 then
        droneAM:deployAtZone(params.zone)
        trigger.action.outTextForCoalition(2, 'Reaper drone deployed over ' .. params.zone.zone .. '. Contact Springfield on 241.00 AM ', 30)
    else
        return 'Can only target enemy zone'
    end
end)


  ------------------------------ END 9 line jtac AM END ----------------------------------


  ----------------------------- START 9 line jtac fm START ---------------------------

Group.getByName('JTAC9linefm'):destroy()
local jtacTargetMenu3 = nil
local droneFM = JTAC9linefmr:new({name = 'JTAC9linefm'})  -- Renamed to droneFM for clarity
bc:registerShopItem('9linefm', '9 line Jtac FM ', 0, function(sender)
    if jtacTargetMenu3 then
        return 'Choose target zone from F10 menu'
    end
    
    local spawnAndOrbit3 = function(target)
        if jtacTargetMenu3 then
            local zn = bc:getZoneByName(target)
            droneFM:deployAtZone(zn)
		trigger.action.outTextForCoalition(2, 'Reaper drone deployed over ' .. target .. '. Contact Uzi on 31.00 FM ', 30)            
            jtacTargetMenu3 = nil
        end
    end
    
    jtacTargetMenu3 = bc:showTargetZoneMenu(2, 'Deploy JTAC to Zone', spawnAndOrbit3, 1)
    trigger.action.outTextForCoalition(2, 'Choose which zone to deploy JTAC at from F10 menu', 15)
end,
function(sender, params)
    if params.zone and params.zone.side == 1 then
        droneFM:deployAtZone(params.zone)
        trigger.action.outTextForCoalition(2, 'Reaper drone deployed over ' .. params.zone.zone .. '. Contact Uzi on 31.00 FM ', 30)
    else
        return 'Can only target enemy zone'
    end
end)



  -------------------------- END 9 line jtac FM END ----------------------------------



local casTargetMenu = nil
Group.getByName('cas1'):destroy()
Group.getByName('cas2'):destroy()
Group.getByName('cas3'):destroy()
Group.getByName('cas4'):destroy()
Group.getByName('cas5'):destroy()
bc:registerShopItem('cas', 'F-16C Ground Attack ', 400, function(sender)
    local grname = 'cas1'
        if (zones.ramonairbase.side == 2 and zones.kedemhatzerim.side == 2 and zones.ovda.side == 1) then
        grname = 'cas2'
		elseif (zones.birhasanah.side == 1 and zones.ovda.side == 2 and zones.stcatherine.side == 2) then
        grname = 'cas3'
		elseif (zones.birhasanah.side == 2 and zones.samgolf.side == 2 and zones.azzaqaziq.side == 1) then
        grname = 'cas4'
		elseif (zones.azzaqaziq.side == 2 and zones.samindia.side == 2 and zones.abusuwayr.side == 2) then
        grname = 'cas5'
    end

    local gr = Group.getByName(grname)
    if Utils.isGroupActive(gr) then
        return 'Ground attack mission still in progress'
    end

    mist.respawnGroup(grname, true)

    if casTargetMenu then
        return 'Choose target zone from F10 menu'
    end

    local launchAttack = function(target)
        if casTargetMenu then
            if Group.getByName(grname) then
                local err = bc:engageZone(target, grname)
                if err then
                    return err
                end

                trigger.action.outTextForCoalition(2, 'F-16C engaging groups at ' .. target, 15)
            else
                trigger.action.outTextForCoalition(2, 'Group has left the area or has been destroyed', 15)
            end

            casTargetMenu = nil
        end
    end

    casTargetMenu = bc:showTargetZoneMenu(2, 'F-16C Target', launchAttack, 1)

    trigger.action.outTextForCoalition(2, 'F-16C on route. Choose target zone from F10 menu for ' .. grname, 15)
end,
function(sender, params)
    if params.zone and params.zone.side == 1 then
        local grname = 'cas1'
        if (zones.ramonairbase.side == 2 and zones.kedemhatzerim.side == 2 and zones.ovda.side == 1) then
        grname = 'cas2'
		elseif (zones.birhasanah.side == 1 and zones.ovda.side == 2 and zones.stcatherine.side == 2) then
        grname = 'cas3'
		elseif (zones.birhasanah.side == 2 and zones.samgolf.side == 2 and zones.azzaqaziq.side == 1) then
        grname = 'cas4'
		elseif (zones.azzaqaziq.side == 2 and zones.samindia.side == 2 and zones.abusuwayr.side == 2) then
        grname = 'cas5'
    end

        local gr = Group.getByName(grname)
        if gr and gr:getSize() > 0 and gr:getController():hasTask() then
            return 'Ground attack mission still in progress'
        end

        mist.respawnGroup(grname, true)
        mist.scheduleFunction(function(target)
            if Group.getByName(grname) then
                local err = bc:engageZone(target, grname)
                if err then
                    return err
                end

                trigger.action.outTextForCoalition(2, 'F-16C engaging groups at ' .. target, 15)
            end
        end, {params.zone.zone}, timer.getTime() + 2)
    else
        return 'Can only target enemy zone'
    end
end)

local seadTargetMenu = nil
Group.getByName('sead1'):destroy()
Group.getByName('sead2'):destroy()
Group.getByName('sead3'):destroy()
Group.getByName('sead4'):destroy()
Group.getByName('sead5'):destroy()

bc:registerShopItem('sead', 'F-16C SEAD mission ', 500, function(sender)
		local grname = 'sead1'
        if (zones.ramonairbase.side == 2 and zones.kedemhatzerim.side == 2 and zones.ovda.side == 1) then
        grname = 'sead2'
    elseif (zones.birhasanah.side == 1 and zones.ovda.side == 2 and zones.stcatherine.side == 2) then
        grname = 'sead3'
	elseif (zones.birhasanah.side == 2 and zones.samgolf.side == 2 and zones.azzaqaziq.side == 1) then
        grname = 'sead4'
	elseif (zones.azzaqaziq.side == 2 and zones.samindia.side == 2 and zones.abusuwayr.side == 2) then
        grname = 'sead5'
    end

    local gr = Group.getByName(grname)
    if Utils.isGroupActive(gr) then
        return 'SEAD mission still in progress'
    end

    mist.respawnGroup(grname, true)

    if seadTargetMenu then
        return 'Choose target zone from F10 menu'
    end

    local launchAttack = function(target)
        if seadTargetMenu then
            if Group.getByName(grname) then
                local err = bc:engageZone(target, grname)
                if err then
                    return err
                end

                trigger.action.outTextForCoalition(2, 'F-16C Vipers engaging SAMs at ' .. target, 15)
            else
                trigger.action.outTextForCoalition(2, 'Group has left the area or has been destroyed', 15)
            end

            seadTargetMenu = nil
        end
    end

    seadTargetMenu = bc:showTargetZoneMenu(2, 'SEAD Target', launchAttack, 1)

    trigger.action.outTextForCoalition(2, 'F-16C Vipers on route. Choose target zone from F10 menu for ' .. grname, 15)
end,
	function(sender, params)
    if params.zone and params.zone.side == 1 then
        local grname = 'sead1'
        if (zones.ramonairbase.side == 2 and zones.kedemhatzerim.side == 2 and zones.ovda.side == 1) then
        grname = 'sead2'
		elseif (zones.birhasanah.side == 1 and zones.ovda.side == 2 and zones.stcatherine.side == 2) then
        grname = 'sead3'
		elseif (zones.birhasanah.side == 2 and zones.samgolf.side == 2 and zones.azzaqaziq.side == 1) then
        grname = 'sead4'
		elseif (zones.azzaqaziq.side == 2 and zones.samindia.side == 2 and zones.abusuwayr.side == 2) then
        grname = 'sead5'
    end

        local gr = Group.getByName(grname)
        if gr and gr:getSize() > 0 and gr:getController():hasTask() then
            return 'SEAD mission still in progress'
        end

        mist.respawnGroup(grname, true)
        mist.scheduleFunction(function(target)
            if Group.getByName(grname) then
                local err = bc:engageZone(target, grname)
                if err then
                    return err
                end

                trigger.action.outTextForCoalition(2, 'F-16C Vipers engaging SAMs at ' .. target, 15)
            end
        end, {params.zone.zone}, timer.getTime() + 2)
    else
        return 'Can only target enemy zone'
    end
end)


    bc:addShopItem(2, 'cap', -1)
    bc:addShopItem(2, 'cas', -1)
    bc:addShopItem(2, 'sead', -1)
    bc:addShopItem(2, 'supplies', -1)
    bc:addShopItem(2, 'jtac', -1)
    bc:addShopItem(2, 'armor', -1)
    bc:addShopItem(2, 'artillery', -1)
    bc:addShopItem(2, 'recon', -1)
    bc:addShopItem(2, 'airdef', -1)
	bc:addShopItem(2, '9lineam', -1)
	bc:addShopItem(2, '9linefm', -1)
	
	
  

supplyZones = {
	'Blue Carrier',
	
	'Sde Dov',	
	'Ben-Gurion', 
	'Palmahim', 
	'Tel Nof', 
	'Hatzor', 
	'Kedem-Hatzerim', 
	'Nevatim', 
	'Ramon Airbase',
	'El Gora',
	'El Arish',
	'Ovda',
	'St Catherine',
	'Abu Rudeis',
	'Bir Hasanah',
	'Melez',
	'Baluza',
	'Al Mansurah',
	'As Salihiyah',
	'Al Ismailiyah',
	'Abu Suwayr',
	'AzZaqaziq',
	'Difarsuwar Airfield',
	'Fayed',
	'Kibrit Air Base',
	'Bilbeis Air Base',
	'Inshas Airbase',
	'Cairo International Airbport',
	'Wadi al Jandali',
	'Cairo West',
	'Sharm El Sheikh International Airport',
	'Hurghada International Airport',
	'Beni Suef',
	'Birma Air Base',
	
	'FARP-Alpha',
	'FARP-Bravo',
	'FARP-Charlie',
	'FARP-Delta',
	'FARP-Echo',
	'FARP-Foxtrot',
	'FARP-Golf',
	'FARP-Hotel',
	'FARP-India',
	'FARP-Juliett',
	'FARP-Kilo',
	'FARP-Lima',
	'FARP-Mike',
	'Quwaysina',
	'Kom Awshim'
}

lc = LogisticCommander:new({battleCommander = bc, supplyZones = supplyZones})
lc:init()

bc:loadFromDisk() --will load and overwrite default zone levels, sides, funds and available shop items
bc:init()
bc:startRewardPlayerContribution(15,{infantry = 10, ground = 20, sam = 40, airplane = 50, ship = 250, helicopter=50, crate=200, rescue = 100})
HercCargoDropSupply.init(bc)

GlobalSettings.defaultRespawns[1]['supply'] = { dead=45*60, hangar=15*60, preparing=5*60}
GlobalSettings.defaultRespawns[1]['patrol'] = { dead=30*60, hangar=15*60, preparing=8*60}
GlobalSettings.setDifficultyScaling(0.7,1)


evc = EventCommander:new({ decissionFrequency=30*60, decissionVariance=30*60, skipChance = 10})
evc:init()


Group.getByName('evt-shiptercept1'):destroy()
Group.getByName('evt-shiptercept2'):destroy()
Group.getByName('evt-shiptercept3'):destroy()
local shipDieEvent = nil
evc:addEvent({
	id='shiptercept',
	action = function()
	
		local ships = {'evt-shiptercept1','evt-shiptercept2','evt-shiptercept3'}
		local choice = math.random(1,#ships)
		
		mist.respawnGroup(ships[choice], true)
		
		local shipDied = function(event)
			if event.id==30 then
				if event.initiator and event.initiator.getName then
					local name = event.initiator:getName()
					if type(name)=="string" and name:find('^evt%-shiptercept') then
						mist.removeEventHandler(shipDieEvent)
						shipDieEvent = nil
						trigger.action.outTextForCoalition(2,'Enemy supply ship destroyed.\n+500 credits',15)
						bc:addFunds(2,500)
					end
				end
			end
		end
		shipDieEvent = mist.addEventHandler(shipDied)
	end,
	canExecute = function()
		if math.random(1,100) < 70 then return false end
		
		if Group.getByName('evt-shiptercept1') then return false end
		if Group.getByName('evt-shiptercept2') then return false end
		if Group.getByName('evt-shiptercept3') then return false end
		
		return true
	end
})

Group.getByName('evt-cargointercept1'):destroy()
Group.getByName('evt-cargointercept2'):destroy()
Group.getByName('evt-cargointercept3'):destroy()
local cargoDieEvent = nil
evc:addEvent({
	id='cargointercept',
	action = function()
	
		local planes = {'evt-cargointercept1','evt-cargointercept2','evt-cargointercept3'}
		local choice = math.random(1,#planes)
		
		mist.respawnGroup(planes[choice], true)
		
		local cargoDie = function(event)
			if event.id==30 then
				if event.initiator and event.initiator.getName then
					local name = event.initiator:getName()
					if type(name)=="string" and name:find('^evt%-cargointercept') then
						mist.removeEventHandler(cargoDieEvent)
						cargoDieEvent = nil
						trigger.action.outTextForCoalition(2,'Enemy cargo plane destroyed.\n+500 credits',15)
						bc:addFunds(2,500)
					end
				end
			end
		end
		cargoDieEvent = mist.addEventHandler(cargoDie)
	end,
	canExecute = function()
		if math.random(1,100) < 70 then return false end
		
		if bc:getZoneByName('Quwaysina').side ~= 1 then return false end
		if bc:getZoneByName('Cairo West').side ~= 1 then return false end
		
		if Group.getByName('evt-cargointercept1') then return false end
		if Group.getByName('evt-cargointercept2') then return false end
		if Group.getByName('evt-cargointercept3') then return false end
		
		return true
	end
})

mc = MissionCommander:new({side = 2, battleCommander = bc, checkFrequency = 60})

mc:trackMission({
	title = "Intercept cargo plane",
	description = "Find and destroy the enemy cargo plane taking and destroy it.",
	messageStart = "New mission: Intercept cargo plane",
	messageEnd = "Mission ended: Intercept cargo plane",
	startAction = function() trigger.action.outSoundForCoalition(2,"radio1.ogg") end,
	endAction = function() trigger.action.outSoundForCoalition(2,"cancel.ogg") end,
	isActive = function()
		if Group.getByName('evt-cargointercept1') then return true end
		if Group.getByName('evt-cargointercept2') then return true end
		if Group.getByName('evt-cargointercept3') then return true end
		
		return false
	end
})

mc:trackMission({
	title = "Destroy cargo & battle ships",
	description = "Find and destroy the enemy cargo & battle ships sailing and destroy it.!",
	messageStart = "New mission: Destroy cargo & battle ships",
	messageEnd = "Mission ended: Destroy cargo & battle ships",
	startAction = function() trigger.action.outSoundForCoalition(2,"radio2.ogg") end,
	endAction = function() trigger.action.outSoundForCoalition(2,"cancel.ogg") end,
	isActive = function()
		if Group.getByName('evt-shiptercept1') then return true end
		if Group.getByName('evt-shiptercept2') then return true end
		if Group.getByName('evt-shiptercept3') then return true end
		
		return false
	end
})

resupplyTarget = nil
mc:trackMission({
    title = function() return "Resupply " .. resupplyTarget end,
    description = function() return "Deliver supplies to " .. resupplyTarget end,
    messageStart = function() return "New mission: Resupply " .. resupplyTarget end,
    messageEnd = function() return "Mission ended: Resupply " .. resupplyTarget end,
    startAction = function()
        if not missionCompleted then
            trigger.action.outSoundForCoalition(2, "ding.ogg")
        end
    end,
    endAction = function()
        resupplyTarget = nil
        if not missionCompleted then
            trigger.action.outSoundForCoalition(2, "cancel.ogg")
        end
    end,
    isActive = function()
        if not resupplyTarget then return false end

        local targetzn = bc:getZoneByName(resupplyTarget)
        return targetzn:canRecieveSupply()
    end
})

attackTarget = nil
mc:trackMission({
    title = function() return "Attack " .. attackTarget end,
    description = function() return "Destroy enemy forces at " .. attackTarget end,
    messageStart = function() return "New mission: Attack " .. attackTarget end,
    messageEnd = function() return "Mission ended: Attack " .. attackTarget end,
    startAction = function()
        if not missionCompleted then
            trigger.action.outSoundForCoalition(2, "cas.ogg")
        end
    end,
    endAction = function()
        attackTarget = nil
        if not missionCompleted then
            trigger.action.outSoundForCoalition(2, "cancel.ogg")
        end
    end,
    isActive = function()
        if not attackTarget then return false end

        local targetzn = bc:getZoneByName(attackTarget)
        return targetzn.side == 1
    end
})

captureTarget = nil
mc:trackMission({
    title = function() return "Capture " .. captureTarget end,
    description = function() return captureTarget .. " is neutral. Capture it by delivering supplies" end,
    messageStart = function() return "New mission: Capture " .. captureTarget end,
    messageEnd = function() return "Mission ended: Capture " .. captureTarget end,
    startAction = function()
        if not missionCompleted then
            trigger.action.outSoundForCoalition(2, "ding.ogg")
        end
    end,
    endAction = function()
        captureTarget = nil
        if not missionCompleted then
            trigger.action.outSoundForCoalition(2, "cancel.ogg")
        end
    end,
    isActive = function()
        if not captureTarget then return false end

        local targetzn = bc:getZoneByName(captureTarget)
        return targetzn.side == 0 and targetzn.active
    end
})

function generateCaptureMission()
    if captureTarget ~= nil then return end
    
    local validzones = {}
    for _,v in ipairs(bc.zones) do
        
        if v.active and v.side == 0 and (not v.NeutralAtStart or v.firstCaptureByRed) then
            
            table.insert(validzones, v.zone)
        end
    end
    
    if #validzones == 0 then return end
    
    local choice = math.random(1, #validzones)
    if validzones[choice] then
        captureTarget = validzones[choice]
        return true
    end
end



function generateAttackMission()
	if attackTarget ~= nil then return end
		
	local validzones = {}
	for _,v in ipairs(bc.connections) do
		local to = bc:getZoneByName(v.to)
		local from = bc:getZoneByName(v.from)
		
		if from.side ~= to.side and from.side ~= 0  and to.side ~= 0 and from.active and to.active then
			if from.side == 1 then
				table.insert(validzones, from.zone)
			elseif to.side == 1 then
				table.insert(validzones, to.zone)
			end
		end
	end
	
	if #validzones == 0 then return end
	
	local choice = math.random(1, #validzones)
	if validzones[choice] then
		attackTarget = validzones[choice]
		return true
	end
end

function generateSupplyMission()
	if resupplyTarget ~= nil then return end
		
	local validzones = {}
	for _,v in ipairs(bc.zones) do
		if v.side == 2 and v:canRecieveSupply() then
			table.insert(validzones, v.zone)
		end
	end
	
	if #validzones == 0 then return end
	
	local choice = math.random(1, #validzones)
	if validzones[choice] then
		resupplyTarget = validzones[choice]
		return true
	end
end

timer.scheduleFunction(function(_, time)
	if generateCaptureMission() then
		return time+300
	else
		return time+120
	end
end, {}, timer.getTime() + 20)

timer.scheduleFunction(function(_, time)
	if generateAttackMission() then
		return time+300
	else
		return time+120
	end
end, {}, timer.getTime() + 40)

timer.scheduleFunction(function(_, time)
	if generateSupplyMission() then
		return time+300
	else
		return time+120
	end
end, {}, timer.getTime() + 60)

mc:init()

env.info("Mission Setup : is completed!")