local AirbossStennis = AIRBOSS:New("CVN-72")

local playerZoneVisits = {}
local globalCallsignAssignments = {}

local atisZones = {
    ["Ben-Gurion"] = {frequency = 270.50, airbaseName = AIRBASE.Sinai.Ben_Gurion, runways = {"08", "26", "12", "30", "03", "21"}},
    ["Ramon Airbase"] = {frequency = 270.60, airbaseName = AIRBASE.Sinai.Ramon_Airbase, runways = {"25L", "07R"}},
    ["Ovda"] = {frequency = 270.70, airbaseName = AIRBASE.Sinai.Ovda, runways = {"12L", "03R"}},
    ["Melez"] = {frequency = 270.80, airbaseName = AIRBASE.Sinai.Melez, runways = {"33R", "15L"}},
    ["Wadi al Jandali"] = {frequency = 270.90, airbaseName = AIRBASE.Sinai.Wadi_al_Jandali, runways = {"01R", "19L"}},
    ["Red Carrier"] = {frequency = 305.50, airbaseName = "CVN-72"},
    ["Blue Carrier"] = {frequency = 305.50, airbaseName = "CVN-73"},
	["Kedem-Hatzerim"] = {frequency = 270.90, airbaseName = AIRBASE.Sinai.Hatzerim, runways = {"28L", "28R", "10L", "10R"}},
	["Nevatim"] = {frequency = 270.90, airbaseName = AIRBASE.Sinai.Nevatim, runways = {"08R", "08L", "07", "26L", "26R", "25"}},
	["St Catherine"] = {frequency = 270.80, airbaseName = AIRBASE.Sinai.St_Catherine, runways = {"35", "17"}},
	["Al Mansurah"] = {frequency = 270.80, airbaseName = AIRBASE.Sinai.Al_Mansurah, runways = {"35", "32", "14", "17"}},
	["As Salihiyah"] = {frequency = 270.80, airbaseName = AIRBASE.Sinai.As_Salihiyah, runways = {"20R", "20L", "02L", "02R"}},
	["Al Ismailiyah"] = {frequency = 270.80, airbaseName = AIRBASE.Sinai.Al_Ismailiyah, runways = {"31", "13"}},
	["Abu Suwayr"] = {frequency = 270.80, airbaseName = AIRBASE.Sinai.Abu_Suwayr, runways = {"29", "11", "09", "27"}},
	["AzZaqaziq"] = {frequency = 270.80, airbaseName = AIRBASE.Sinai.AzZaqaziq, runways = {"36L", "36R", "18R", "18L"}},
	["Sharm El Sheikh International Airport"] = {frequency = 270.80, airbaseName = AIRBASE.Sinai.Sharm_El_Sheikh_International_Airport, runways = {"22L", "22R", "04R", "04L"}},
	["Hurghada International Airport"] = {frequency = 270.80, airbaseName = AIRBASE.Sinai.Hurghada_International_Airport, runways = {"16L", "16R", "34R", "34L"}},
	["Beni Suef"] = {frequency = 270.80, airbaseName = AIRBASE.Sinai.Beni_Suef, runways = {"36R", "36L", "18L", "18R"}},
	["Kom Awshim"] = {frequency = 270.80, airbaseName = AIRBASE.Sinai.Kom_Awshim, runways = {"16", "15", "33", "34"}},
	["Birma Air Base"] = {frequency = 270.80, airbaseName = AIRBASE.Sinai.Birma_Air_Base, runways = {"14R", "14L", "32R", "32L"}},
	["Quwaysina"] = {frequency = 270.90, airbaseName = AIRBASE.Sinai.Quwaysina, runways = {"34", "16"}},
	["Kibrit Air Base"] = {frequency = 270.90, airbaseName = AIRBASE.Sinai.Kibrit_Air_Base, runways = {"32L", "32R", "14L", "14R"}}
	
	
}

local atisZoneNames = {
	["Hatzerim"] = {frequency = 270.90, airbaseName = AIRBASE.Sinai.Hatzerim, runways = {"28L", "28R", "10L", "10R"}},
	["Kedem"] = {frequency = 270.90, airbaseName = AIRBASE.Sinai.Kedem, runways = {"28", "10"}},
	
	
}

-- Define all zones
local allZones = {
    "Ben-Gurion", "Ramon Airbase", "Red Carrier", "Blue Carrier", "Ovda", "Melez", "Wadi al Jandali",
    "Sde Dov", "Palmahim", "Tel Nof", "Hatzor", "Kedem-Hatzerim", "Nevatim", "El Gora", "El Arish",
    "St Catherine", "Abu Rudeis", "Bir Hasanah", "Baluza", "As Salihiyah", "Al Ismailiyah", "Abu Suwayr",
    "Difarsuwar Airfield", "Fayed", "Kibrit Air Base", "Al Mansurah", "AzZaqaziq", "Bilbeis Air Base",
    "Inshas Airbase", "Cairo International Airport", "Cairo West", "FARP-Alpha", "FARP-Bravo", "FARP-Charlie",
    "FARP-Delta", "FARP-Echo", "FARP-Foxtrot", "FARP-Golf", "FARP-Hotel", "FARP-India", "FARP-Juliett",
    "FARP-Kilo", "FARP-Lima", "FARP-Mike", "Quwaysina", "Birma Air Base", "Kom Awshim", 
	"Beni Suef", "Hurghada International Airport", "Sharm El Sheikh International Airport"
}

airbaseStatics = {
	["FARP Alpha"] = {"Farpalphaammo", "Farpalphafuel", "Farpalphatent1", "Farpalphatent2", "Farpalphatent3", "Farpalphatent4", "Farpalphacommand", "Farpalphawind"},
    ["FARP Bravo"] = {"Farbravoammo", "Farpbravofuel", "Farpbravotent1", "Farpbravotent2", "Farpbravotent3", "Farpbravotent4", "Farpbravocommand", "Farpbravowind"},
    ["FARP Charlie"] = {"Farpcharliammo", "Farpcharliefuel", "Farpcharlietent1", "Farpcharlietent2", "Farpcharlietent3", "Farpcharlietent4", "Farpcharlicenter", "Farpcharliewind"},
    ["FARP Delta"] = {"Farpdeltaammo", "Farpdeltafuel", "Farpdeltatent1", "Farpdeltatent2", "Farpdeltatent3", "Farpdeltatent4", "Farpdeltacenter", "Farpdeltawind"},
    ["FARP Echo"] = {"Farpechoammo", "Farpechofuel", "Farpechotent1", "Farpechotent2", "Farpechotent3", "Farpechotent4", "Farpechocommand", "Farpechowind"},
    ["FARP Foxtrot"] = {"Farpfoxtrotammo", "Farpfoxtrotfuel", "Farpfoxtrottent1", "Farpfoxtrottent2", "Farpfoxtrottent3", "Farpfoxtrottent4", "Farpfoxtrotcommand", "Farpfoxtrotwind"},
    ["FARP Golf"] = {"Farpgolfammo", "Farpgolffuel", "Farpgolftent1", "Farpgolftent2", "Farpgolftent3", "Farpgolftent4", "Farpgolfcommand", "Farpgolfwind"},
    ["FARP Hotel"] = {"FarpHotelammo", "Farphotelfuel", "Farphoteltent1", "Farphoteltent2", "Farphoteltent3", "Farphoteltent4", "Farphotelcommand", "Farphotelwind"},
    ["FARP India"] = {"Farpindiaammo", "Farpindiafuel", "Farpindiatent1", "Farpindiatent2", "Farpindiatent3", "Farpindiatent4", "Farpindiacommand", "Farpindiawind"},
    ["FARP Juliett"] = {"Farpjuliettammo", "Farpjuliettfuel", "Farpjulietttent1", "Farpjulietttent2", "Farpjulietttent3", "Farpjulietttent4", "Farpjulietttent1command", "Farpjuliettwind"},
    ["FARP Kilo"] = {"Farpkiloammo", "Farpkilofuel", "Farpkilotent1", "Farpkilotent2", "Farpkilotent3", "Farpkilotent4", "Farpkilocommand", "Farpkilowind"},
    ["FARP Lima"] = {"Farplimaammo", "Farplimafuel", "Farplimatent1", "Farplimatent2", "Farplimatent3", "Farplimatent4", "Farplimacommand", "Farplimawind"},
    ["FARP Mike"] = {"Farpmikeammo", "Farpmikefuel", "Farpmiketent1", "Farpmiketent2", "Farpmiketent3", "Farpmiketent4", "Farpmikecommand", "Farpmikewind"},
}

function RespawnStaticsForAirbase(airbaseName, coalitionSide)
    local statics = airbaseStatics[airbaseName]
    if not statics then
        return
    end

    local countryID
    if coalitionSide == coalition.side.BLUE then
        countryID = country.id.USA
    elseif coalitionSide == coalition.side.RED then
        countryID = country.id.RUSSIA
		
    else
        return
    end

    
    for _, staticName in ipairs(statics) do
        local static = STATIC:FindByName(staticName)
        if static then
            static:ReSpawn(countryID)
        end
    end
end

for airbaseName, _ in pairs(airbaseStatics) do
    local airbase = AIRBASE:FindByName(airbaseName)
    if airbase then
        local coalitionSide = airbase:GetCoalition()
        RespawnStaticsForAirbase(airbaseName, coalitionSide)
    end
end



local aircraftAssignments = {
    ["F.A.18"] = {
        ["Arctic1"] = {
            IFFs = {1400, 1401, 1402, 1403},
            assignments = {}
        },
        ["Bender2"] = {
            IFFs = {1404, 1405, 1406, 1407},
            assignments = {}
        },
        ["Crimson3"] = {
            IFFs = {1410, 1411, 1412, 1413},
            assignments = {}
        },
        ["Dusty4"] = {
            IFFs = {1300, 1301, 1302, 1303},
            assignments = {}
        },
        ["Lion3"] = {
            IFFs = {1310, 1311, 1312, 1313},
            assignments = {}
        },
    },
    ["F.16CM"] = {
        ["Jester1"] = {
            IFFs = {1500, 1501, 1502, 1503},
            assignments = {}
        },
        ["Indy9"] = {
            IFFs = {1510, 1511, 1512, 1513},
            assignments = {}
        },
        ["Venom4"] = {
            IFFs = {1610, 1611, 1612, 1613},
            assignments = {}
        },
    },
    ["A.10C"] = {
        ["Hawg8"] = {
            IFFs = {1330, 1331, 1332, 1333},
            assignments = {}
        },
        ["Tusk2"] = {
            IFFs = {1350, 1351, 1352, 1353},
            assignments = {}
        },
        ["Pig7"] = {
            IFFs = {1340, 1341, 1342, 1343},
            assignments = {}
        },
    },
    ["AH.64D"] = {
        ["Rage9"] = {
            IFFs = {1610, 1611, 1612, 1613},
            assignments = {}
        },
        ["Salty1"] = {
            IFFs = {1620, 1621, 1622, 1623},
            assignments = {}
        },
    },
    ["AJS37"] = {
        ["Fenris6"] = {
            IFFs = {1060, 1061, 1062, 1063},
            assignments = {}
        },
        ["Grim7"] = {
            IFFs = {1070, 1071, 1072, 1073},
            assignments = {}
        },
    },
    ["UH.1H"] = {
        ["Nitro5"] = {
            IFFs = {1050, 1051, 1052, 1053},
            assignments = {}
        },
    },
}


local zoneAssignments = {}

function logZoneAssignments()
    env.info("Zone Assignments:")
    for zone, assignments in pairs(zoneAssignments) do
        env.info("Zone: " .. zone)
        for fullCallsign, assignedPlayer in pairs(assignments) do
            env.info("    Callsign: " .. fullCallsign .. " -> Player: " .. assignedPlayer)
        end
    end
end


local function isCallsignUsedInOtherZones(fullCallsign, currentZone)
    for zone, assignments in pairs(zoneAssignments) do
        if assignments[fullCallsign] then
            if zone ~= currentZone then
                return true  -- Callsign is used in another zone, don't reuse
            elseif assignments[fullCallsign] then
                return true  -- Callsign is used in the current zone
            end
        end
    end
    return false
end



function getAssignedCallsignAndIFF(groupName)
    for prefix, typeAssignments in pairs(aircraftAssignments) do
        if string.find(groupName, prefix) then
            for callsign, details in pairs(typeAssignments) do
                for i, IFF in ipairs(details.IFFs) do
                    local fullCallsign = callsign .. "" .. i
                    if not isCallsignUsedInOtherZones(fullCallsign, zoneName) then
                        return fullCallsign, IFF
                    end
                end
            end
        end
    end
    return nil, nil
end

function findOrAssignSlot(playerName, groupName, zoneName)
    -- Ensure there's a tracking table for the current zone
    zoneAssignments[zoneName] = zoneAssignments[zoneName] or {}

    -- Iterate through the aircraftAssignments to find the correct prefix and flight assignment
    for prefix, typeAssignments in pairs(aircraftAssignments) do
        if string.find(groupName, prefix) then
            local preferredOrder
            if prefix == "F.A.18" then
                preferredOrder = {"Arctic1", "Bender2", "Crimson3", "Dusty4", "Lion3"}
            elseif prefix == "F.16CM" then
                preferredOrder = {"Jester1", "Indy9", "Venom4"}
            elseif prefix == "A.10C" then
                preferredOrder = {"Hawg8", "Tusk2", "Pig7"}
            elseif prefix == "AH.64D" then
                preferredOrder = {"Rage9", "Salty1"}
            elseif prefix == "AJS37" then
                preferredOrder = {"Fenris6", "Grim7"}
            elseif prefix == "UH.1H" then
                preferredOrder = {"Nitro5"}
            end

            -- First, check if the main callsigns are used in the **current zone**
            local availableMainCallsign = nil
            local existingPrefixInZone = nil

            -- Check for existing call signs within the current zone
            for _, mainCallsign in ipairs(preferredOrder) do
                for i = 1, #typeAssignments[mainCallsign].IFFs do
                    local fullCallsign = mainCallsign .. "" .. i
                    if zoneAssignments[zoneName][fullCallsign] then
                        -- If there is already an Arctic1 or similar in the current zone, use this prefix
                        existingPrefixInZone = mainCallsign
                        break
                    end
                end
                if existingPrefixInZone then
                    break
                end
            end

            -- If no Arctic1 (or similar) is in the current zone, check if Arctic1 is in **other zones**
            if not existingPrefixInZone then
                for _, mainCallsign in ipairs(preferredOrder) do
                    local isUsedInOtherZones = false
                    for zone, assignments in pairs(zoneAssignments) do
                        if zone ~= zoneName then  -- We are only interested in checking other zones
                            for fullCallsign, assignedPlayer in pairs(assignments) do
                                if string.find(fullCallsign, mainCallsign) then
                                    isUsedInOtherZones = true
                                    break
                                end
                            end
                        end
                    end
                    -- If the main callsign is **not used in other zones**, assign it to the current zone
                    if not isUsedInOtherZones then
                        availableMainCallsign = mainCallsign
                        break
                    end
                end
            else
                availableMainCallsign = existingPrefixInZone  -- Continue with the same flight prefix in this zone
            end

            -- Now assign a specific slot within the available main callsign
            if availableMainCallsign then
                for i, IFF in ipairs(typeAssignments[availableMainCallsign].IFFs) do
                    local fullCallsign = availableMainCallsign .. "" .. i
                    if not zoneAssignments[zoneName][fullCallsign] then
                        -- Update zoneAssignments
                        zoneAssignments[zoneName][fullCallsign] = playerName

                        -- Update globalCallsignAssignments
                        globalCallsignAssignments[playerName] = {callsign = fullCallsign, zoneName = zoneName}

                        env.info(string.format("Assigned %s to player %s in zone %s", fullCallsign, playerName, zoneName))
                        logZoneAssignments()  -- Log the current state of zoneAssignments
                        return fullCallsign, IFF
                    end
                end
            end

            -- If we cannot assign from the main callsign, check if the first callsign is available before cycling back
            for _, mainCallsign in ipairs(preferredOrder) do
                for i, IFF in ipairs(typeAssignments[mainCallsign].IFFs) do
                    local fullCallsign = mainCallsign .. "" .. i
                    if not isCallsignUsedInOtherZones(fullCallsign, zoneName) and zoneAssignments[zoneName][fullCallsign] == nil then
                        -- Update zoneAssignments
                        zoneAssignments[zoneName][fullCallsign] = playerName

                        -- Update globalCallsignAssignments
                        globalCallsignAssignments[playerName] = {callsign = fullCallsign, zoneName = zoneName}

                        env.info(string.format("Assigned %s to player %s in zone %s (cycled back, first available)", fullCallsign, playerName, zoneName))
                        logZoneAssignments()  -- Log the current state of zoneAssignments
                        return fullCallsign, IFF
                    end
                end
            end

            -- Fallback logic: Assign the first available slot in the current zone
            for _, mainCallsign in ipairs(preferredOrder) do
                for i, IFF in ipairs(typeAssignments[mainCallsign].IFFs) do
                    local fullCallsign = mainCallsign .. "" .. i
                    if not zoneAssignments[zoneName][fullCallsign] then
                        -- Update zoneAssignments
                        zoneAssignments[zoneName][fullCallsign] = playerName

                        -- Update globalCallsignAssignments
                        globalCallsignAssignments[playerName] = {callsign = fullCallsign, zoneName = zoneName}

                        env.info(string.format("Assigned %s to player %s in zone %s (cycled back, fallback)", fullCallsign, playerName, zoneName))
                        logZoneAssignments()  -- Log the current state of zoneAssignments
                        return fullCallsign, IFF
                    end
                end
            end
        end
    end

    -- If no assignment could be made, return nil values
    return nil, nil
end


function releaseSlot(playerName, zoneName)
    -- Check if the player has an assigned callsign in the specified zone
    if zoneAssignments[zoneName] then
        for callsign, assignedPlayer in pairs(zoneAssignments[zoneName]) do
            if assignedPlayer == playerName then
                -- Release the callsign
                zoneAssignments[zoneName][callsign] = nil

                -- Also remove the global assignment
                globalCallsignAssignments[playerName] = nil

                env.info(string.format("Released %s from player %s in zone %s", callsign, playerName, zoneName))
                break
            end
        end
    end
end


function sendGreetingToPlayer(playerUnitID, greetingMessage)
    trigger.action.outTextForUnit(playerUnitID, greetingMessage, 55)
end



function sendDetailedMessageToPlayer(args)
    local playerUnitID = args[1]
    local message = args[2]
    local playerGroupID = args[3]
    trigger.action.outTextForUnit(playerUnitID, message, 120)
    trigger.action.outSoundForGroup(playerGroupID, "admin.wav")
end


local function getAltimeter()
    local coord = COORDINATE:NewFromVec3({x = 0, y = 0, z = 0})
    local pressure_hPa = coord:GetPressure(0)  
    local pressureInHg = pressure_hPa * 0.0295300
    return string.format("Altimeter %.2f", pressureInHg)
end


local function getBRC()
    if AirbossStennis then
        local brc = AirbossStennis:GetBRC()
        return string.format("BRC %d°", brc)
    else
        return "BRC data unavailable"
    end
end


local function getAirbaseWind(airbaseName)
    local airbase = AIRBASE:FindByName(airbaseName)
    if airbase then
        local airbaseCoord = airbase:GetCoordinate()  
        local windDirection, windSpeed = airbaseCoord:GetWind(0)
        if windDirection and windSpeed then
            local windSpeedKnots = math.floor(windSpeed * 1.94384)
            windDirection = (windDirection + 360) % 360
            return string.format("Wind is %03d° at %d", windDirection, windSpeedKnots), windDirection
        else
            return "Wind data unavailable", nil
        end
    else
        return "Airbase not found", nil
    end
end


local function calculateFallbackRunway(zoneName)
    local zoneInfo = atisZones[zoneName]
    if not zoneInfo or not zoneInfo.runways then
        trigger.action.outText("No runway data available for zone: " .. zoneName, 10)
        return "Active runway data unavailable."
    end
    
    
    local _, windDirection = getAirbaseWind(zoneInfo.airbaseName)
    if windDirection == nil then
        return "Wind direction data unavailable."
    end

    local bestRunway = nil
    local smallestDelta = 360

   
    for _, runway in ipairs(zoneInfo.runways) do
        local runwayHeading = tonumber(runway:sub(1, 2)) * 10
        local delta = math.abs(runwayHeading - windDirection)
        if delta > 180 then 
            delta = 360 - delta
        end
        if delta < smallestDelta then
            smallestDelta = delta
            bestRunway = runway
        end
    end

    if bestRunway then
        return string.format("Active runway is %s", bestRunway)
    else
        return "No suitable runway found based on wind."
    end
end


local function fetchActiveRunway(zoneName)
    local airbase = AIRBASE:FindByName(atisZones[zoneName].airbaseName)
    if not airbase then
        trigger.action.outText("Airbase/FARP conflict detected or airbase not found: " .. atisZones[zoneName].airbaseName, 10)
        return "Airbase data unavailable."
    end

    local windMessage, windDirection = getAirbaseWind(atisZones[zoneName].airbaseName)
    if windDirection == nil then
        return "Wind direction data unavailable."
    end

    local activeRunway = airbase:GetRunwayIntoWind()
    if activeRunway then
        local runwayName = airbase:GetRunwayName(activeRunway)
        if runwayName and runwayName ~= "" then
            
            return string.format("Active runway is %s", runwayName)
        end
    end

    
    return calculateFallbackRunway(zoneName, windDirection)
end

local function getCarrierWind()
    local cvn = UNIT:FindByName("CVN-72")
    if cvn then
        local cvnCoord = cvn:GetCoordinate()
        local windDirection, windSpeed = cvnCoord:GetWind(0)
        if windDirection and windSpeed then
            local windSpeedKnots = windSpeed * 1.94384  
            windDirection = (windDirection + 360) % 360
            return string.format("Wind is %03d° at %d", windDirection, windSpeedKnots)
        else
            return "Wind data unavailable"
        end
    else
        return "Carrier not found"
    end
end


local function getPlayerWind(playerCoord)
    local playerPosition = playerCoord:GetVec3()
    local windVector = atmosphere.getWind(playerPosition)
    if windVector then
        local windSpeedMps = math.sqrt(windVector.x^2 + windVector.z^2)
        local windSpeedKnots = math.floor(windSpeedMps * 1.94384)
        local originalWindDirection = math.deg(math.atan2(windVector.z, windVector.x))
        originalWindDirection = (originalWindDirection + 360) % 360
        local originatingWindDirection = (originalWindDirection + 180) % 360
        return string.format("Wind is %03d° at %d", originatingWindDirection, windSpeedKnots), originatingWindDirection
    else
        return "Wind data unavailable", nil
    end
end

local function getPlayerTemperature(playerCoord)
    local playerPosition = playerCoord:GetVec3()
    local temperatureCelsius = playerCoord:GetTemperature(playerPosition.y)  -- Getting temperature at the player's altitude (ASL)
    
    if temperatureCelsius then
        return string.format("Temperature is %d°C", temperatureCelsius)
    else
        return "Temperature data unavailable"
    end
end

local function getPlayerWeatherReport(playerCoord)
    local windMessage, windDirection = getPlayerWind(playerCoord)
    local temperatureMessage = getPlayerTemperature(playerCoord)

    -- Combine wind and temperature messages into a single weather report
    local weatherReport = string.format("%s\n%s", windMessage, temperatureMessage)

    return weatherReport
end

-- ATIS MENU --

local function sendATISInformation(client, group, zoneName)
    local messageText
    
    if string.find(zoneName, "Carrier") then
        local windMessage = getCarrierWind()
        local brcMessage = getBRC()  
        local altimeterMessage = getAltimeter()
        messageText = string.format("ATIS for Mother:\n\n%s, %s\n\n%s", windMessage, altimeterMessage, brcMessage or "BRC data unavailable")
        MESSAGE:New(messageText, 15, ""):ToUnit(client)
    else
        
        local windMessage, windDirection = getAirbaseWind(atisZones[zoneName].airbaseName)
        if windMessage == "Wind data unavailable" or windMessage == "Airbase not found" then
            messageText = string.format("ATIS for %s:\n\n%s", zoneName, windMessage)
        else
            local runwayInfo = fetchActiveRunway(zoneName, windDirection)
            messageText = string.format("ATIS for %s:\n\n%s, %s\n\n%s.", zoneName, windMessage, getAltimeter(), runwayInfo or "Runway information not available")
        end
        MESSAGE:New(messageText, 20, ""):ToUnit(client)
    end
end


local MainMenu = {}
local static = STATIC:FindByName("EventMan", true)


function SetupATISMenu(client)
    local group = client:GetGroup()
    if not group then
        
        return
    end

    local groupID = group:GetName()

   
    if MainMenu[groupID] then
        MainMenu[groupID]:Remove()
    end

    
    local mainMenu = MENU_GROUP:New(group, "ATIS Information")
    MainMenu[groupID] = mainMenu

    local currentMenu = mainMenu
    local menuItemCount = 1

   
    MENU_GROUP_COMMAND:New(group, "Get ATIS for Mother", mainMenu, sendATISInformation, client, group, "Carrier")

 
    for zoneName, details in pairs(atisZones) do
        if not zoneName:find("Carrier") then
            local airbase = AIRBASE:FindByName(details.airbaseName)
            if airbase and airbase:GetCoalitionName() == 'Blue' then
                if menuItemCount >= 9 then
                    currentMenu = MENU_GROUP:New(group, "Next Page...", mainMenu)
                    menuItemCount = 0
                end
                MENU_GROUP_COMMAND:New(group, "Get ATIS for " .. zoneName, currentMenu, sendATISInformation, client, group, zoneName)
                menuItemCount = menuItemCount + 1
            end
        end
    end
end


local lastMessageTime = {}


function static:onBaseCapture(_event)
    local event = _event -- Core.Event#EVENTDATA
    if event.id == EVENTS.BaseCaptured and event.Place and event.Place:GetCoalition() == coalition.side.BLUE then
        local capturedBaseName = event.Place:GetName()  
		local coalitionSide = event.Place:GetCoalition()

		
		RespawnStaticsForAirbase(capturedBaseName, coalitionSide)
        
        
        if (atisZoneNames[capturedBaseName] or atisZones[capturedBaseName]) and event.Place:GetCoalition() == coalition.side.BLUE then  
		
            local currentTime = timer.getTime()  
            local lastSent = lastMessageTime[capturedBaseName] or 0 
			
            if currentTime - lastSent > 5 then
                
                lastMessageTime[capturedBaseName] = currentTime

                
                local clientSet = SET_CLIENT:New():FilterCategories("plane"):FilterCoalitions("blue"):FilterAlive():FilterOnce()
                clientSet:ForEachClient(function(client)
                    SetupATISMenu(client)  
					
                    local messageText = string.format("ATIS for %s is now available.", capturedBaseName)
                    MESSAGE:New(messageText, 20, ""):ToClient(client)
                end)
            end
        end
    end
end

function static:onPlayerSpawn(_event)
    local event = _event
    if event.id == EVENTS.PlayerEnterAircraft and event.IniUnit and event.IniPlayerName then
        local player = event.IniUnit
        local playerName = player:GetPlayerName()
        
        if player:GetUnitCategory() == Unit.Category.AIRPLANE then
            SetupATISMenu(player)
        end
        
        local group = player:GetGroup()
        local groupName = group:GetName()
        
        -- Iterate through all zones
        for _, zoneName in ipairs(allZones) do
            local zone = ZONE:New(zoneName)
            if zone and zone:IsCoordinateInZone(player:GetCoordinate()) then
                local playerUnitID = player:GetID()
                local playerGroupID = player:GetGroup():GetID()
                
                -- Check if this is a new visit for the player
                local isNewVisit = not playerZoneVisits[playerName] or not playerZoneVisits[playerName][zoneName]
                playerZoneVisits[playerName] = playerZoneVisits[playerName] or {}
                playerZoneVisits[playerName][zoneName] = true

                -- Find or assign the callsign and IFF for the player
                local assignedCallsign, assignedIFF = findOrAssignSlot(playerName, groupName, zoneName)

                -- Prepare messages
                local altimeterMessage = getAltimeter()
                local temperatureMessage = getPlayerTemperature(player:GetCoordinate())
                local greetingMessage, detailedMessage
                
                -- If the player is near a carrier
                if string.find(zoneName, "Carrier") then
                    local brcMessage = getBRC()
                    local carrierWindMessage = getCarrierWind()

                    if assignedCallsign and assignedIFF then
                        greetingMessage = string.format("Welcome aboard Abraham Lincoln, %s!\n\nYou have been assigned to %s, IFF %d.\n\nStandby for weather report from Mother.", playerName, assignedCallsign, assignedIFF)
                        detailedMessage = string.format("Welcome aboard Abraham Lincoln, %s!\n\n%s, %s, %s\n\n%s\n\nOnce 7 miles out, push Tactical on CH 3.", assignedCallsign, carrierWindMessage, temperatureMessage, altimeterMessage, brcMessage)
                    else
                        greetingMessage = string.format("Welcome aboard Abraham Lincoln, %s!\n\nStandby for weather and BRC.", playerName)
                        detailedMessage = string.format("Welcome aboard Abraham Lincoln, %s!\n\n%s, %s, %s\n\n%s\n\nOnce 7 miles out, push Tactical on CH 3.", playerName, carrierWindMessage, temperatureMessage, altimeterMessage, brcMessage)
                    end

                else
                    -- If the player is at an airbase
                    local windMessage, displayWindDirection

                    if atisZones[zoneName] then
                        windMessage, displayWindDirection = getAirbaseWind(atisZones[zoneName].airbaseName)
                        local activeRunwayMessage = fetchActiveRunway(zoneName, displayWindDirection)

                        if isNewVisit then
                            if assignedCallsign and assignedIFF then
                                greetingMessage = string.format("Welcome to %s, %s!\n\nYou have been assigned to %s, IFF %d.\n\nStandby for weather and ATIS information.", zoneName, playerName, assignedCallsign, assignedIFF)
                                detailedMessage = string.format("Welcome to %s, %s!\n\n%s, %s, %s.\n\n%s.\n\nOnce airborne push Tactical on CH 3.", zoneName, assignedCallsign, windMessage, temperatureMessage, altimeterMessage, activeRunwayMessage)
                            else
                                greetingMessage = string.format("Welcome to %s, %s!\n\nStandby for weather information.", zoneName, playerName)
                                detailedMessage = string.format("Welcome to %s, %s!\n\n%s, %s, %s.\n\n%s.\n\nOnce airborne push Tactical on CH 3.", zoneName, playerName, windMessage, temperatureMessage, altimeterMessage, activeRunwayMessage)
                            end

                        else
                            if assignedCallsign and assignedIFF then
                                greetingMessage = string.format("Welcome back to %s, %s!\n\nYou have been assigned to %s, IFF %d.\n\nYou'll receive the latest weather and ATIS info shortly.", zoneName, playerName, assignedCallsign, assignedIFF)
                                detailedMessage = string.format("Welcome back to %s, %s!\n\n%s, %s, %s.\n\n%s.\n\nOnce airborne push Tactical on CH 3.", zoneName, assignedCallsign, windMessage, temperatureMessage, altimeterMessage, activeRunwayMessage)
                            else
                                greetingMessage = string.format("Welcome back to %s, %s!\n\nStandby for updated weather information.", zoneName, playerName)
                                detailedMessage = string.format("Welcome back to %s, %s!\n\n%s, %s, %s.\n\n%s.\n\nOnce airborne push Tactical on CH 3.", zoneName, playerName, windMessage, temperatureMessage, altimeterMessage, activeRunwayMessage)
                            end
                        end
                    else
                        -- Handle other locations not defined as specific airbases
                        local playerCoord = player:GetCoordinate()
                        windMessage, _ = getPlayerWind(playerCoord)
                        temperatureMessage = getPlayerTemperature(playerCoord)

                        if isNewVisit then
                            if assignedCallsign and assignedIFF then
                                greetingMessage = string.format("Welcome to %s, %s!\n\nYou have been assigned to %s, IFF %d.\n\nStandby for weather information.", zoneName, playerName, assignedCallsign, assignedIFF)
                                detailedMessage = string.format("Welcome to %s, %s!\n\n%s, %s, %s.\n\nOnce airborne push Tactical on CH 3.\n\nDon't forget supplies.", zoneName, assignedCallsign, windMessage, temperatureMessage, altimeterMessage)
                            else
                                greetingMessage = string.format("Welcome to %s, %s!\n\nStandby for weather information.", zoneName, playerName)
                                detailedMessage = string.format("Welcome to %s, %s!\n\n%s, %s, %s.\n\nOnce airborne push Tactical on CH 3.\n\nDon't forget supplies.", zoneName, playerName, windMessage, temperatureMessage, altimeterMessage)
                            end

                        else
                            if assignedCallsign and assignedIFF then
                                greetingMessage = string.format("Welcome back to %s, %s!\n\nYou have been assigned to %s, IFF %d.\n\nYou'll receive updated weather information shortly.", zoneName, playerName, assignedCallsign, assignedIFF)
                                detailedMessage = string.format("Welcome back to %s, %s!\n\n%s, %s, %s.\n\nOnce airborne push Tactical on CH 3.\n\nDon't forget supplies.", zoneName, assignedCallsign, windMessage, temperatureMessage, altimeterMessage)
                            else
                                greetingMessage = string.format("Welcome back to %s, %s!\n\nStandby for updated weather information.", zoneName, playerName)
                                detailedMessage = string.format("Welcome back to %s, %s!\n\n%s, %s, %s.\n\nOnce airborne push Tactical on CH 3.\n\nDon't forget supplies.", zoneName, playerName, windMessage, temperatureMessage, altimeterMessage)
                            end
                        end
                    end
                end

                -- Send the messages
                sendGreetingToPlayer(playerUnitID, greetingMessage)
                timer.scheduleFunction(sendDetailedMessageToPlayer, {playerUnitID, detailedMessage, playerGroupID}, timer.getTime() + 60)
            end
        end
    end
end


function static:onPlayerLeaveUnit(_event)
    env.info("onPlayerLeaveUnit called")

    local event = _event

    if event.id == EVENTS.PlayerLeaveUnit or event.id == EVENTS.PilotDead then
        if event.IniPlayerName then
            local playerName = event.IniPlayerName
            env.info("Player leaving unit: " .. playerName)

            if globalCallsignAssignments[playerName] then
                local callsignInfo = globalCallsignAssignments[playerName]
                local zoneName = callsignInfo.zoneName
                env.info("Player had assignment: " .. callsignInfo.callsign .. " in zone " .. zoneName)

                releaseSlot(playerName, zoneName)
                globalCallsignAssignments[playerName] = nil
            else
                env.info("No global assignment found for player: " .. playerName)
            end
        else
            env.info("IniPlayerName is nil. Player might have disconnected without a proper event.")

            local clientSet = SET_CLIENT:New():FilterCategories("plane"):FilterCoalitions("blue"):FilterAlive():FilterOnce()

            for playerName, callsignInfo in pairs(globalCallsignAssignments) do
                local isPlayerAlive = false

                clientSet:ForEachClient(function(client)
                    if client:GetPlayerName() == playerName then
                        isPlayerAlive = true
                    end
                end)

                if not isPlayerAlive then
                    local zoneName = callsignInfo.zoneName
                    env.info("Removing dead or disconnected player: " .. playerName .. " from zone " .. zoneName)
                    releaseSlot(playerName, zoneName)
                    globalCallsignAssignments[playerName] = nil
                end
            end
        end
    else
        env.info("Event ID does not match PlayerLeaveUnit or PilotDead")
    end
end



static:HandleEvent(EVENTS.PlayerEnterAircraft, static.onPlayerSpawn)
static:HandleEvent(EVENTS.BaseCaptured, static.onBaseCapture)
static:HandleEvent(EVENTS.PlayerLeaveUnit, static.onPlayerLeaveUnit)

